#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=lupo.ico
#AutoIt3Wrapper_outfile=Manager.exe
#AutoIt3Wrapper_UseUpx=N
#AutoIt3Wrapper_Res_Description=Suite Manager - The official manager of Lupo PenSuite
#AutoIt3Wrapper_Res_Fileversion=3.5.0.0
#AutoIt3Wrapper_Res_ProductVersion=3.5.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Lupo PenSuite Team
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_Icon_Add=icons\cu.ico
#AutoIt3Wrapper_Res_Icon_Add=icons\is.ico
#AutoIt3Wrapper_Res_Icon_Add=icons\si.ico
#AutoIt3Wrapper_Res_Icon_Add=icons\ma.ico
#AutoIt3Wrapper_Res_Icon_Add=icons\hlp.ico
#AutoIt3Wrapper_Res_Icon_Add=icons\guide.ico
#AutoIt3Wrapper_Res_Icon_Add=icons\no.ico
#AutoIt3Wrapper_Res_Field=Website|http://www.lupopensuite.com
#AutoIt3Wrapper_Res_Field=E-Mail|comment at the website
#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6 -w 7
#AutoIt3Wrapper_Run_Obfuscator=Y
#Obfuscator_Parameters=/SF /SV /OM /CF=0 /CN=0 /CS=0 /CV=0
#AutoIt3Wrapper_res_requestedExecutionLevel=asInvoker
#AutoIt3Wrapper_Outfile_Type=exe
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Info: http://www.autoitscript.com/autoit3/scite/docs/AutoIt3Wrapper.htm
; Icons added to the resources can be used with TraySetIcon(@ScriptFullPath, -5) etc. and are stored with numbers -5, -6...

#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>
#include <IE.au3>
#include <GUIListView.au3>
#include <GUIImageList.au3>
#include <GUIMenu.au3>

Opt('MustDeclareVars', 1)
Opt('TrayIconHide', 1)

Global $Global_LupoDir = StringTrimRight(@ScriptDir, 17) ; remove string "\Launcher\Manager"
Global $Global_SuiteName = "Lupo PenSuite", $Global_SuiteExe = "\Lupo_PenSuite.exe", $Global_INI = @ScriptDir & '\config.ini'
Global $Global_Associator = "..\..\Apps\Extra\eXpresso\eXpresso.exe", $Global_Site = 'http://www.lupopensuite.com/'
Global $Global_TempFile = @ScriptDir & '\Data\temp.txt', $Global_7zip = @ScriptDir & '\Data\7za\7za.exe', $Global_BackupFolder = 'LupoBackup-' & @YEAR & '-' & @MON & '-' & @MDAY
Global $Global_SuiteVersion = IniRead($Global_INI, 'General', 'Version', '0'), $Global_SuiteEdition = IniRead($Global_INI, 'General', 'Edition', 'Full')
Global $Global_CustomDir = IniRead($Global_INI, 'General', 'CustomFolder', 'None'), $Global_UseCustom = IniRead($Global_INI, 'General', 'UseCustomFolder', 'NO')
Global $Global_Languages = 'Arabic|Brazilian Port.|Catalan|Chinese Simpl.|Chinese Trad.|Czech|Danish|Deutsch|Dutch|English|Finnish|French|Greek|Hungarian|Italian|Japanese|Korean|Norwegian|Polish|Portuguese|Romanian|Russian|Serbian|Slovak|Swedish|Spanish|Turkish|Ukrainian'
Global $Global_Error1 = 'Error during the download process. Try again later.'
Global $Global_Error2 = 'Unable to contact the server. Verify your internet connection, otherwise the service could be disabled for maintenance.'
Global $Global_Error3 = ' interrupted by the user. You can continue it later.'
Global $Global_Error4 = 'Some software updates are failed. Try again later.'
Global $Global_Error5 = 'You need to select a folder that contains backup files.' & @LF & 'Something like "' & $Global_BackupFolder & '".'
Global $Global_MyApps, $Global_MyFiles, $Global_ListView, $Global_ListViewHidden, $Global_Dummy

_Main()

Func _Main()
	Local $hMainGUI, $sBrowser, $sData, $iRunPage, $sCheckManager, $aButton[7]

	$sBrowser = IniRead($Global_INI, "General", "Browser", "")
	If $sBrowser = "" Then $sBrowser = "..\..\Apps\Firefox Portable\FirefoxPortable.exe"

	If FileExists($Global_INI) = 0 Then
		$sData = "Version=0" & @LF & "Edition=Full" & @LF & "Language=English" & @LF & "AutoCheck=OFF" & @LF & "AutoCheckApps=OFF" & @LF & "AutoCheckMan=" & @LF & "UpdateMode=Keep" & @LF & "Browser=" & $sBrowser & @LF & "CustomFolder=None" & @LF & "UseCustomFolder=NO" & @LF & "BackupDir="
		IniWriteSection($Global_INI, "General", $sData)

		$sData = "ProxyHost=" & @LF & "ProxyPort=" & @LF & "ProxyUsername=" & @LF & "ProxyPassword="
		IniWriteSection($Global_INI, "Proxy", $sData)

		$sData = "IconSet=5"
		IniWriteSection($Global_INI, "Switcher", $sData)

		$sData = "FirstTime=YES" & @LF & "FixPath=YES" & @LF & "Associate=OFF" & @LF & "Associator=" & $Global_Associator
		IniWriteSection($Global_INI, "Starter", $sData)
	EndIf

	$hMainGUI = GUICreate("Suite Manager", 460, 250)
	GUISetIcon("lupo.ico")
	GUISetBkColor(0x0A0A52)
	If FileExists(@ScriptDir & "\OLD.exe") Then FileDelete(@ScriptDir & "\OLD.exe")

	If $CmdLine[0] > 0 Then ; Background Mode.
		If $CmdLine[1] = "ON" Then _Checker($hMainGUI, 1)
		If $CmdLine[2] = "ON" Then _Apps($hMainGUI, 1, $sBrowser)
		Exit
	EndIf

	If $Global_SuiteVersion = "0" Then
		$aButton[0] = GUICtrlCreateLabel($Global_SuiteName, 36, 15, 260, 20)
	Else
		$aButton[0] = GUICtrlCreateLabel($Global_SuiteName & " (v" & $Global_SuiteVersion & " " & $Global_SuiteEdition & ")", 20, 15, 260, 20)
	EndIf
	GUICtrlSetTip(-1, "Visit our website and find additional apps for your collection")
	GUICtrlSetColor(-1, 0xE5E5E5)
	GUICtrlSetFont(-1, 9, 600)
	GUICtrlSetCursor(-1, 0)

	$aButton[1] = GUICtrlCreateButton("Options", 280, 10, 70, 24)
	GUICtrlSetTip(-1, "Configure some general settings of your collection")
	$aButton[2] = GUICtrlCreateButton("Guide", 370, 10, 70, 24)
	GUICtrlSetTip(-1, "Read the offline guide of your collection")

	GUICtrlCreateGroup("", 10, 38, 440, 200)
	$aButton[3] = GUICtrlCreateButton("Check Updates", 25, 38+21, 100, 28)
	GUICtrlSetTip(-1, "Check for updates of the entire collection")
	GUICtrlCreateLabel("It allows you to check and download new releases of the Suite (from Options you can configure the automatic check).", 135, 38+22, 304, 38)
	GUICtrlSetColor(-1, 0xE5E5E5)
	$aButton[4] = GUICtrlCreateButton("Import Settings", 25, 38+21+45, 100, 28)
	GUICtrlSetTip(-1, "Import settings of the entire collection")
	GUICtrlCreateLabel("It allows you to import application settings, MyApps and MyFiles from a previous release of the Suite to the new one.", 135, 38+22+45, 304, 38)
	GUICtrlSetColor(-1, 0xE5E5E5)
	$aButton[5] = GUICtrlCreateButton("Manage Apps", 25, 38+21+45*2, 100, 28)
	GUICtrlSetTip(-1, "Manage single applications of the collection")
	GUICtrlCreateLabel("It allows you to keep your programs updated, to backup setting files and to remove unwanted apps from the Suite.", 135, 38+22+45*2, 304, 38)
	GUICtrlSetColor(-1, 0xE5E5E5)
	$aButton[6] = GUICtrlCreateButton("Switch Icon-Sets", 25, 38+21+45*3, 100, 28)
	GUICtrlSetTip(-1, "Change icons of the launcher menu")
	GUICtrlCreateLabel("It allows you to change the group of icons used for software categories of the Suite menu.", 135, 38+22+45*3, 304, 38)
	GUICtrlSetColor(-1, 0xE5E5E5)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUISetState()
	$sCheckManager = IniRead($Global_INI, "General", "AutoCheckMan", "")
	If $sCheckManager = "" Then
		_Welcome($hMainGUI)
	ElseIf $sCheckManager = "ON" Then
		_Update_Manager()
	EndIf

	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				ExitLoop

			Case $aButton[0]
				$iRunPage = Run($sBrowser & " -new-tab " & $Global_Site, "", @SW_MAXIMIZE)
				If $iRunPage = 0 Then _IECreate($Global_Site, 1, 1, 0)

			Case $aButton[1]
				_Options($hMainGUI)

			Case $aButton[2]
				_Guide()

			Case $aButton[3]
				_Checker($hMainGUI, 0)

			Case $aButton[4]
				_Importer($hMainGUI)

			Case $aButton[5]
				_Apps($hMainGUI, 0, $sBrowser)

			Case $aButton[6]
				_Switcher($hMainGUI)

		EndSwitch
	WEnd
EndFunc   ;==>_Main

Func _Options($hMainGUI)
	Local $hGUI, $hOK, $hCancel, $sState, $iDecision, $sProxyHost, $sProxyPort, $sProxyUser, $sProxyPassword, $fCreateAutorun = 0, $fPortableMode = 0
	Local $hFileOpen, $sLine, $aCheckbox[4], $sAssociatorPath, $aRadio[2], $hCombo, $sLanguage
	Local $sKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run"
	Local $sAutorun = StringLeft(@ScriptDir, 2) & '\autorun.inf'

	$hGUI = GUICreate("Options", 290, 328, -1, -1, -1, $WS_EX_TOOLWINDOW, $hMainGUI)

	GUICtrlCreateGroup("General Options", 8, 6, 274, 104)
	$aCheckbox[0] = GUICtrlCreateCheckbox("Autorun Lupo PenSuite...", 18, 20+2, 260, 20)
	$aRadio[0] = GUICtrlCreateRadio("at device connection (from flash drive)", 46, 20*2, 220, 20)
	GUICtrlSetTip(-1, 'It creates an "autorun.inf" file in device root')
	$aRadio[1] = GUICtrlCreateRadio("at system startup (from hard disk)", 46, 20*3, 220, 20)
	GUICtrlSetTip(-1, 'It creates a registry key with startup settings')
	$aCheckbox[1] = GUICtrlCreateCheckbox("Use portable file associations with Lupo PenSuite", 18, 20*4+2, 260, 20)
	GUICtrlSetTip(-1, 'It will start and close the file associator together with the Suite')
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("Update Options", 8, 114, 274, 90)
	$aCheckbox[2] = GUICtrlCreateCheckbox("Auto-check for manager updates at its startup", 18, 114+16, 260, 20)
	$aCheckbox[3] = GUICtrlCreateCheckbox("Auto-check for global updates at the Suite startup", 18, 114+16+20, 260, 20)
	GUICtrlCreateLabel("Select language for updates:", 18, 114+16+46)
	GUICtrlSetTip(-1, "It will download also the correct language pack with Suite updates")
	$sLanguage = IniRead($Global_INI, "General", "Language", "English")
	$hCombo = GUICtrlCreateCombo("", 160, 114+16+43, 104, 19)
    GUICtrlSetData(-1, $Global_Languages, $sLanguage)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("Proxy Options", 8, 210, 274, 77)
	GUICtrlCreateLabel("Host:", 18, 210+20)
	$sProxyHost = GUICtrlCreateInput(IniRead($Global_INI, "Proxy", "ProxyHost", ""), 46, 210+18, 142, 20)
	GUICtrlCreateLabel("Port:", 202, 210+20)
	$sProxyPort = GUICtrlCreateInput(IniRead($Global_INI, "Proxy", "ProxyPort", ""), 230, 210+18, 40, 20)
	GUICtrlCreateLabel("User:", 18, 210+20+28)
	$sProxyUser = GUICtrlCreateInput(IniRead($Global_INI, "Proxy", "ProxyUsername", ""), 46, 210+18+28, 77, 20)
	GUICtrlCreateLabel("Password:", 136, 210+20+28)
	$sProxyPassword = GUICtrlCreateInput(IniRead($Global_INI, "Proxy", "ProxyPassword", ""), 192, 210+18+28, 78, 20)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlSetState($aRadio[0], 1)
	If RegRead($sKey, $Global_SuiteName) = $Global_LupoDir & $Global_SuiteExe Then
		GUICtrlSetState($aCheckbox[0], 1)
		GUICtrlSetState($aRadio[1], 1)
	EndIf
	If FIleExists($sAutorun) Then
		$hFileOpen = FileOpen($sAutorun, 0)
		While 1
			$sLine = FileReadLine($hFileOpen)
			If @error = -1 Then ExitLoop
			If StringInStr($sLine, $Global_SuiteName) Then
				GUICtrlSetState($aCheckbox[0], 1)
				GUICtrlSetState($aRadio[0], 1)
				$fPortableMode = 1
				ExitLoop
			EndIf
		WEnd
		FileClose($hFileOpen)
	EndIf
	If GUICtrlRead($aCheckbox[0]) <> 1 Then
		GUICtrlSetState($aRadio[0], $GUI_DISABLE)
		GUICtrlSetState($aRadio[1], $GUI_DISABLE)
	EndIf
	$sAssociatorPath = IniRead($Global_INI, "Starter", "Associator", "")
	If $sAssociatorPath = "" Then $sAssociatorPath = $Global_Associator
	If IniRead($Global_INI, "Starter", "Associate", "OFF") = "ON" And FileExists($sAssociatorPath) Then GUICtrlSetState($aCheckbox[1], 1)
	If IniRead($Global_INI, "General", "AutoCheckMan", "ON") = "ON" Then GUICtrlSetState($aCheckbox[2], 1)
	If IniRead($Global_INI, "General", "AutoCheck", "OFF") = "ON" Then GUICtrlSetState($aCheckbox[3], 1)

	$hOK = GUICtrlCreateButton("OK", 145 - 80 - 30, 294, 80, 26)
	$hCancel = GUICtrlCreateButton("Cancel", 145 + 30, 294, 80, 26)
	GUICtrlSetState($hOK, $GUI_FOCUS)

	GUISetState()
	While 1
		Switch GUIGetMsg()
			Case $hOK
				$sState = "OFF"
				If GUICtrlRead($aCheckbox[1]) = 1 Then
					IniWrite($Global_INI, "Starter", "Associator", $sAssociatorPath)
					$sState = "ON"
				EndIf
				IniWrite($Global_INI, "Starter", "Associate", $sState)
				$sState = "OFF"
				If GUICtrlRead($aCheckbox[2]) = 1 Then $sState = "ON"
				IniWrite($Global_INI, "General", "AutoCheckMan", $sState)
				$sState = "OFF"
				If GUICtrlRead($aCheckbox[3]) = 1 Then $sState = "ON"
				IniWrite($Global_INI, "General", "AutoCheck", $sState)
				IniWrite($Global_INI, "General", "Language", GUICtrlRead($hCombo))
				IniWrite($Global_INI, "Proxy", "ProxyHost", GUICtrlRead($sProxyHost))
				IniWrite($Global_INI, "Proxy", "ProxyPort", GUICtrlRead($sProxyPort))
				IniWrite($Global_INI, "Proxy", "ProxyUsername", GUICtrlRead($sProxyUser))
				IniWrite($Global_INI, "Proxy", "ProxyPassword", GUICtrlRead($sProxyPassword))
				If GUICtrlRead($aCheckbox[0]) = 1 Then
					If GUICtrlRead($aRadio[0]) = 1 Then
						$fCreateAutorun = 1
						If FIleExists($sAutorun) And $fPortableMode <> 1 Then
							$iDecision = MsgBox(0x40004, "Autorun already exists", 'An "autorun.inf" file already exists in this drive.' & @LF & "Do you want to substitute it with this new one?")
							If $iDecision <> 6 Then $fCreateAutorun = 0
						EndIf
						If $fCreateAutorun = 1 Then
							If DriveGetType(StringLeft($Global_LupoDir, 3)) = "Removable" And StringInStr($Global_LupoDir, " ") Then
								MsgBox(0x40000, "Autorun not actived", 'Autorun "at device connection" cannot be actived, because the Suite directory contains spaces. Close it and fix its directory to use this feature.')
								$fCreateAutorun = 0
							EndIf
							If DriveGetType(StringLeft($Global_LupoDir, 3)) = "Fixed" Then
								MsgBox(0x40000, "Autorun not actived", 'Autorun "at device connection" cannot be actived, because the Suite is on a fixed hard disk. You need to enable autorun "at system startup" for this purpose.')
								$fCreateAutorun = 0
							EndIf
						EndIf
						If $fCreateAutorun = 1 Then
							$hFileOpen = FileOpen($sAutorun, 2)
							FileWriteLine($hFileOpen, "[autorun]")
							FileWriteLine($hFileOpen, "open=.\" & StringTrimLeft($Global_LupoDir, 3) & $Global_SuiteExe)
							FileWriteLine($hFileOpen, "action=Start " & $Global_SuiteName)
							FileWriteLine($hFileOpen, "icon=.\" & StringTrimLeft($Global_LupoDir, 3) & $Global_SuiteExe)
							FileWriteLine($hFileOpen, "label=" & $Global_SuiteName)
							FileClose($hFileOpen)
						EndIf
					Else
						If DriveGetType(StringLeft($Global_LupoDir, 3)) = "Removable" Then
							MsgBox(0x40000, "Autorun not actived", 'Autorun "at system startup" cannot be actived, because the Suite is on a removable device. You need to enable autorun "at device connection" for this purpose.')
						Else
							If RegRead($sKey, $Global_SuiteName) = "" Then
								$iDecision = 6
							Else
								If RegRead($sKey, $Global_SuiteName) <> $Global_LupoDir & $Global_SuiteExe Then $iDecision = MsgBox(0x40004, "Autorun already exists", "Setting already exists to run a Suite at system startup." & @LF & "Do you want to substitute it with this new one?")
								If $iDecision = 6 Then RegDelete($sKey, $Global_SuiteName)
							EndIf
							If $iDecision = 6 Then
								RegWrite($sKey, $Global_SuiteName, "REG_SZ", $Global_LupoDir & $Global_SuiteExe)
								If RegRead($sKey, "ASuite") = $Global_LupoDir & "\Launcher\ASuite.exe" Then MsgBox(0x40000, "Duplicate startup settings", 'Duplicate startup settings detected. To correctly startup the Suite, you need to uncheck "Start ASuite at system startup" from menu Options.')
							EndIf
						EndIf
					EndIf
				Else
					If RegRead($sKey, $Global_SuiteName) = $Global_LupoDir & $Global_SuiteExe Then RegDelete($sKey, $Global_SuiteName)
					If FIleExists($sAutorun) And $fPortableMode = 1 Then FileDelete($sAutorun)
				EndIf
				ExitLoop

			Case $aCheckbox[1]
				If GUICtrlRead($aCheckbox[1]) = 1 And FileExists($sAssociatorPath) = 0 Then
					$iDecision = MsgBox(0x40004, "Associator not found", "Software for portable file associations not found." & @LF & "Do you want to manually select it?")
					If $iDecision = 6 Then
						$sState = FileOpenDialog("Select your portable file associator", $Global_LupoDir & "\", "Software (*.exe)", 1)
						If @error Then
							GUICtrlSetState($aCheckbox[1], 4)
						Else
							If StringInStr($sState, $Global_LupoDir) Then $sState = "..\.." & StringTrimLeft($sState, StringLen($Global_LupoDir))
							$sAssociatorPath = $sState
						EndIf
					Else
						GUICtrlSetState($aCheckbox[1], 4)
					EndIf
				EndIf

			Case $aCheckbox[0]
				If GUICtrlRead($aCheckbox[0]) = 1 Then
					GUICtrlSetState($aRadio[0], $GUI_ENABLE)
					GUICtrlSetState($aRadio[1], $GUI_ENABLE)
				Else
					GUICtrlSetState($aRadio[0], $GUI_DISABLE)
					GUICtrlSetState($aRadio[1], $GUI_DISABLE)
				EndIf

			Case $hCancel, $GUI_EVENT_CLOSE
				ExitLoop

		EndSwitch
	WEnd

	GUIDelete($hGUI)
EndFunc   ;==>_Options

Func _Downloading($hCheck, $hClose, $hStatusText, $hProgressBar, $sNewVersion)
	Local $hMsg, $sSuiteExe, $sSuitePath, $hDownload, $iDecision, $iSize, $sLanguage, $sLanguageString, $sLanguagePack, $sDownloadLink

	GUICtrlSetState($hCheck, $GUI_ENABLE)
	GUICtrlSetState($hClose, $GUI_DISABLE)
	GUICtrlSetData($hCheck, "Abort")
	GUICtrlSetData($hStatusText, "Downloading...")

	$sLanguage = IniRead($Global_INI, "General", "Language", "")
	If $sLanguage = "" Then $sLanguage = "English"

	If $sLanguage = "Arabic" Then $sLanguageString = "ar-AE"
	If $sLanguage = "Brazilian Port." Then $sLanguageString = "pt-BR"
	If $sLanguage = "Catalan" Then $sLanguageString = "ca-ES"
	If $sLanguage = "Chinese Simpl." Then $sLanguageString = "zh-CN"
	If $sLanguage = "Chinese Trad." Then $sLanguageString = "zh-TW"
	If $sLanguage = "Czech" Then $sLanguageString = "cs-CZ"
	If $sLanguage = "Danish" Then $sLanguageString = "da-DK"
	If $sLanguage = "Deutsch" Then $sLanguageString = "de-DE"
	If $sLanguage = "Dutch" Then $sLanguageString = "nl-NL"
	If $sLanguage = "Finnish" Then $sLanguageString = "fi-FI"
	If $sLanguage = "French" Then $sLanguageString = "fr-FR"
	If $sLanguage = "Greek" Then $sLanguageString = "el-GR"
	If $sLanguage = "Hungarian" Then $sLanguageString = "hu-HU"
	If $sLanguage = "Italian" Then $sLanguageString = "it-IT"
	If $sLanguage = "Japanese" Then $sLanguageString = "ja-JP"
	If $sLanguage = "Korean" Then $sLanguageString = "ko-KR"
	If $sLanguage = "Norwegian" Then $sLanguageString = "nb-NO"
	If $sLanguage = "Polish" Then $sLanguageString = "pl-PL"
	If $sLanguage = "Portuguese" Then $sLanguageString = "pt-PT"
	If $sLanguage = "Romanian" Then $sLanguageString = "ro-RO"
	If $sLanguage = "Russian" Then $sLanguageString = "ru-RU"
	If $sLanguage = "Serbian" Then $sLanguageString = "sr-SR"
	If $sLanguage = "Slovak" Then $sLanguageString = "sk-SK"
	If $sLanguage = "Swedish" Then $sLanguageString = "sv-SE"
	If $sLanguage = "Spanish" Then $sLanguageString = "es-ES"
	If $sLanguage = "Turkish" Then $sLanguageString = "tr-TR"
	If $sLanguage = "Ukrainian" Then $sLanguageString = "uk-UA"
	$sLanguagePack = "Pack_" & $sLanguageString & ".exe"
	$sSuiteExe = "Lupo_PenSuite_v" & $sNewVersion & "_" & $Global_SuiteEdition & ".exe"

	$sDownloadLink = $Global_Site & "downloads/v" & $sNewVersion & "/" & $sSuiteExe
	$sSuitePath = @DesktopDir & '\' & $sSuiteExe
	$iSize = InetGetSize($sDownloadLink)
	$hDownload = InetGet($sDownloadLink, $sSuitePath, 1, 1)
	Do
		$sDownloadLink = InetGetInfo($hDownload, 4)
		$hMsg = GUIGetMsg()
		If $hMsg = $hCheck Or $hMsg = $GUI_EVENT_CLOSE Or $sDownloadLink <> 0 Then
			InetClose($hDownload)
			FileDelete($sSuitePath)
			If $sDownloadLink <> 0 Then MsgBox(0, "Error", $Global_Error1)
			Return SetError(1, 0, 0)
		EndIf
		GUICtrlSetData($hProgressBar, (InetGetInfo($hDownload, 0) / $iSize) * 100)
		Sleep(300)
	Until InetGetInfo($hDownload, 2)
	InetClose($hDownload)
	GUICtrlSetData($hProgressBar, 100)

	If $sLanguage <> "English" Then ; Download Language Pack.
		$sDownloadLink = $Global_Site & "downloads/v" & $sNewVersion & "/" & $sLanguagePack
		$sSuitePath = @DesktopDir & '\' & $sLanguagePack
		$iSize = InetGetSize($sDownloadLink)
		$hDownload = InetGet($sDownloadLink, $sSuitePath, 1, 1)
		Do
			$sDownloadLink = InetGetInfo($hDownload, 4)
			$hMsg = GUIGetMsg()
			If $hMsg = $hCheck Or $hMsg = $GUI_EVENT_CLOSE Or $sDownloadLink <> 0 Then
				InetClose($hDownload)
				FileDelete($sSuitePath)
				If $sDownloadLink <> 0 Then MsgBox(0, "Error", $Global_Error1)
				Return SetError(1, 0, 0)
			EndIf
			GUICtrlSetData($hProgressBar, (InetGetInfo($hDownload, 0) / $iSize) * 100)
			Sleep(300)
		Until InetGetInfo($hDownload, 2)
		InetClose($hDownload)
		GUICtrlSetData($hProgressBar, 100)
	EndIf

	$iDecision = MsgBox(0x40004, "Download completed", $Global_SuiteName & " successfully downloaded." & @LF & "Do you want to start now the extraction of this new release?")
	If $iDecision = 6 Then
		Run(@DesktopDir & '\' & $sSuiteExe)
		Exit
	EndIf
EndFunc   ;==>_Downloading

Func _Checker($hMainGUI, $fBackgroundMode)
	Local $hGUI, $hProgressBar, $hCheck, $hClose, $hStatusText, $iDecision, $sNewVersion

	$hGUI = GUICreate("Check Updates", 290, 84, -1, -1, -1, -1, $hMainGUI)
	GUISetIcon(@ScriptFullPath, -5)
	GUISetBkColor(0x0A0A52)

	$hStatusText = GUICtrlCreateLabel("Click Check to start", 26, 12, 256, 16)
	GUICtrlSetColor(-1, 0xE5E5E5)
	$hProgressBar = GUICtrlCreateProgress(12, 33, 266, 10)
	$hCheck = GUICtrlCreateButton("Check", 145 - 80 - 30, 52, 80, 26)
	$hClose = GUICtrlCreateButton("Close", 145 + 30, 52, 80, 26)
	GUICtrlSetState($hCheck, $GUI_FOCUS)
	_Set_Proxy()

	If $fBackgroundMode = 0 Then ; Normal Process.
		GUISetState()
		While 1
			Switch GUIGetMsg()
				Case $hCheck
					GUICtrlSetData($hStatusText, "Checking...")
					GUICtrlSetState($hCheck, $GUI_DISABLE)
					GUICtrlSetState($hClose, $GUI_DISABLE)
					Sleep(500)
					$sNewVersion = BinaryToString(InetRead($Global_Site & "downloads/ver.txt", 17))
					GUICtrlSetState($hClose, $GUI_ENABLE)
					GUICtrlSetData($hProgressBar, 100)
					GUICtrlSetData($hStatusText, "Check finished")
					If $sNewVersion = $Global_SuiteVersion Then
						GUICtrlSetData($hStatusText, "You have the latest release available")
					ElseIf $sNewVersion <> "" And StringLen($sNewVersion) < 15 Then
						$iDecision = MsgBox(0x40004, "Update available!", "New " & $Global_SuiteName & " v" & $sNewVersion & " available! Do you want to download it?" & @LF & "This may take several minutes (package will be saved on Desktop)")
						If $iDecision = 6 Then _Downloading($hCheck, $hClose, $hStatusText, $hProgressBar, $sNewVersion)
						ExitLoop
					Else
						MsgBox(0x40000, "Check failed", $Global_Error2)
					EndIf

				Case $hClose, $GUI_EVENT_CLOSE
					ExitLoop

			EndSwitch
		WEnd
	Else ; Background Process.
		GUISetState(@SW_HIDE)
		Sleep(2000)
		$sNewVersion = BinaryToString(InetRead($Global_Site & "downloads/ver.txt", 17))
		If $sNewVersion <> $Global_SuiteVersion And $sNewVersion <> "" And StringLen($sNewVersion) < 15 Then
			$iDecision = MsgBox(0x40004, "Update available!", "New " & $Global_SuiteName & " v" & $sNewVersion & " available! Do you want to download it?" & @LF & "This may take several minutes (package will be saved on Desktop)")
			If $iDecision = 6 Then
				GUISetState()
				_Downloading($hCheck, $hClose, $hStatusText, $hProgressBar, $sNewVersion)
			EndIf
		EndIf
	EndIf

	GUIDelete($hGUI)
EndFunc   ;==>_Checker

Func _Update_Manager()
	Local $hDownload, $sNewVersion, $iDecision

	_Set_Proxy()
	$sNewVersion = BinaryToString(InetRead($Global_Site & "downloads/man/ver.txt", 17))
	If $sNewVersion <> FileGetVersion(@ScriptFullPath) And $sNewVersion <> "" Then
		$iDecision = MsgBox(0x40004, "Update available!", "A new version of the Suite Manager is available." & @LF & "Do you want to update it now?")
		If $iDecision = 6 Then
			$hDownload = InetGet($Global_Site & "downloads/man/" & @ScriptName, @ScriptDir & "\NEW.exe", 1)
			If InetGetInfo($hDownload, 4) <> 0 Then
				FileDelete(@ScriptDir & "\NEW.exe")
				MsgBox(0x40000, "Update failed", "Suite Manager update failed. Contact us if the problem persists.")
				Return SetError(1, 0, 0)
			EndIf
			FileMove(@ScriptFullPath, @ScriptDir & "\OLD.exe")
			FileMove(@ScriptDir & "\NEW.exe", @ScriptFullPath)
			Run(@ScriptName)
			Exit
		EndIf
	EndIf
EndFunc   ;==>_Update_Manager

Func _Import_Settings($hParentGUI, $sSourceDir)
	Local $hGUI, $hStart, $hCancel, $fValid, $sLoadedDir, $aCheckbox[3], $aReturnValue[4] = [0, 0, 0, 0]

	$hGUI = GUICreate("Configuration", 284, 169, -1, -1, -1, $WS_EX_TOOLWINDOW, $hParentGUI)
	
	GUICtrlCreateLabel("Important: close the Suite and all portable software.", 13, 10)
	GUICtrlSetFont(-1, -1, 400, 4)
	
	GUICtrlCreateGroup("What components do you want to import?", 9, 36, 266, 92)
	If $Global_SuiteEdition = "Zero" Then
		$aCheckbox[0] = GUICtrlCreateCheckbox("Customized menu (your old menu)", 36, 53, 220, 20)
		GUICtrlSetTip($aCheckbox[0], "It will import the whole Suite menu")
	Else
		$aCheckbox[0] = GUICtrlCreateCheckbox("Application settings (of pre-included apps)", 36, 53, 220, 20)
		GUICtrlSetTip($aCheckbox[0], "It will import settings of default Suite applications")
	EndIf
	GUICtrlSetState($aCheckbox[0], 1)
	$aCheckbox[1] = GUICtrlCreateCheckbox("MyApps (your additional software)", 36, 76, 220, 20)
	GUICtrlSetTip($aCheckbox[1], "It will import all software of MyApps category")
	GUICtrlSetState($aCheckbox[1], 0)
	$aCheckbox[2] = GUICtrlCreateCheckbox("MyFiles (your personal files)", 36, 99, 220, 20)
	GUICtrlSetTip($aCheckbox[2], "It will import all files of portable personal folders")
	GUICtrlSetState($aCheckbox[2], 0)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	
	$hStart = GUICtrlCreateButton("Start", 142-66-20, 136, 66, 24)
	GUICtrlSetTip($hStart, "This procedure cannot be stopped")
	$hCancel = GUICtrlCreateButton("Cancel", 142+20, 136, 66, 24)
	
	GUISetState()
	While 1
		Switch GUIGetMsg()
			Case $aCheckbox[1]
				If GUICtrlRead($aCheckbox[1]) = $GUI_CHECKED And FileExists($Global_MyApps) = 0 Then
					$sLoadedDir = FileSelectFolder("Select your old MyApps folder:", "", 2, $sSourceDir)
					If $sLoadedDir <> "" Then $Global_MyApps = $sLoadedDir
				EndIf
			
			Case $aCheckbox[2]
				If GUICtrlRead($aCheckbox[2]) = $GUI_CHECKED And FileExists($Global_MyFiles) = 0 Then
					$sLoadedDir = FileSelectFolder("Select your old MyFiles folder:", "", 2, $sSourceDir)
					If $sLoadedDir <> "" Then $Global_MyFiles = $sLoadedDir
				EndIf
				
			Case $hStart
				If GUICtrlRead($aCheckbox[0]) = 1 Then
					$aReturnValue[1] = 1
					$aReturnValue[0] = 1
				EndIf
				If GUICtrlRead($aCheckbox[1]) = 1 Then
					$aReturnValue[2] = 1
					$aReturnValue[0] = 1
				EndIf
				If GUICtrlRead($aCheckbox[2]) = 1 Then
					$aReturnValue[3] = 1
					$aReturnValue[0] = 1
				EndIf
				If $aReturnValue[0] = 0 Then
					MsgBox(0, "Alert message", "You have to select at least one component to import.")
				Else
					$fValid = 0
					If GUICtrlRead($aCheckbox[1]) = $GUI_CHECKED And FileExists($Global_MyApps) = 0 Then
						$fValid = 0
					Else
						If GUICtrlRead($aCheckbox[2]) = $GUI_CHECKED And FileExists($Global_MyFiles) = 0 Then
							$fValid = 0
						Else
							$fValid = 1
						EndIf
					EndIf
					If $fValid = 1 Then
						ExitLoop
					Else
						MsgBox(0, "Alert message", "You have to select correct MyApps and MyFiles folders.")
						GUICtrlSetState($aCheckbox[1], 0)
						GUICtrlSetState($aCheckbox[2], 0)
					EndIf
				EndIf
				
			Case $hCancel, $GUI_EVENT_CLOSE
				$aReturnValue[0] = 0
				ExitLoop
				
		EndSwitch
	WEnd

	GUIDelete($hGUI)
	Return $aReturnValue
EndFunc   ;==>_Import_Settings

Func _Copy_XML($sSourceDir, $sTargetDir)
	Local $sLine, $hInputOpen, $hOutputOpen
	Local $sOldXML = $sSourceDir & "\Launcher\ASuite.xml", $sNewXML = $sTargetDir & "\Launcher\ASuite.xml"

	$hInputOpen = FileOpen($sOldXML, 0)
	$hOutputOpen = FileOpen($Global_TempFile, 2)
	While 1
		$sLine = FileReadLine($hInputOpen)
		If @error = -1 Then ExitLoop
		If StringInStr($sLine, '<PathCache>') = 0 Then FileWriteLine($hOutputOpen, $sLine)
	WEnd
	FileClose($hInputOpen)
	FileClose($hOutputOpen)

	FileCopy($Global_TempFile, $sNewXML, 1)
	FileDelete($Global_TempFile)
EndFunc   ;==>_Copy_XML

Func _Import_XML($sSourceDir, $sTargetDir)
	Local $sLine, $hInputOpen, $hOutputOpen
	Local $sOldXML = $sSourceDir & "\Launcher\ASuite.xml", $sNewXML = $sTargetDir & "\Launcher\ASuite.xml"

	$hInputOpen = FileOpen($sNewXML, 0)
	$hOutputOpen = FileOpen($Global_TempFile, 2)
	While StringInStr($sLine, '<Category name="MyApps">') = 0
		$sLine = FileReadLine($hInputOpen)
		FileWriteLine($hOutputOpen, $sLine)
	WEnd
	FileClose($hInputOpen)
	FileClose($hOutputOpen)

	$hInputOpen = FileOpen($sOldXML, 0)
	$hOutputOpen = FileOpen($Global_TempFile, 1)
	While 1
		$sLine = FileReadLine($hInputOpen)
		If @error = -1 Then
			FileClose($hInputOpen)
			FileClose($hOutputOpen)
			Return SetError(1, 0, 0)
		EndIf
		If StringInStr($sLine, '<Category name="MyApps">') Then
			While 1
				$sLine = FileReadLine($hInputOpen)
				If @error = -1 Then
					FileClose($hInputOpen)
					FileClose($hOutputOpen)
					Return SetError(1, 0, 0)
				EndIf
				If StringInStr($sLine, '<Category name="Extra">') Then ExitLoop
				If StringInStr($sLine, '<Category name="Games">') Then ExitLoop
				If StringInStr($sLine, '<Option>') Then ExitLoop
				If StringInStr($sLine, '<PathCache>') = 0 Then FileWriteLine($hOutputOpen, $sLine)
			WEnd
			ExitLoop
		EndIf
	WEnd
	FileClose($hInputOpen)
	FileClose($hOutputOpen)

	$hInputOpen = FileOpen($sNewXML, 0)
	$hOutputOpen = FileOpen($Global_TempFile, 1)
	While 1
		$sLine = FileReadLine($hInputOpen)
		If @error = -1 Then
			FileClose($hInputOpen)
			FileClose($hOutputOpen)
			Return SetError(1, 0, 0)
		EndIf
		If StringInStr($sLine, '<Category name="Extra">') Or StringInStr($sLine, '<Category name="Games">') Or StringInStr($sLine, '<Option>') Then
			While 1
				FileWriteLine($hOutputOpen, $sLine)
				If StringInStr($sLine, '</ASuite>') Then ExitLoop
				$sLine = FileReadLine($hInputOpen)
			WEnd
			ExitLoop
		EndIf
	WEnd
	FileClose($hInputOpen)
	FileClose($hOutputOpen)

	FileCopy($Global_TempFile, $sNewXML, 1)
	FileDelete($Global_TempFile)
EndFunc   ;==>_Import_XML

Func _Import_Apps($sSourceDir, $sTargetDir, $hProgressBar)
	Local $hSearch, $sAppFolder, $iNumberItems = 0, $K = 0

	GUICtrlSetData($hProgressBar, 0)
	If FileExists($sTargetDir) Then
		$hSearch = FileFindFirstFile($sTargetDir & "\*.*")
		While 1
			$sAppFolder = FileFindNextFile($hSearch)
			If @error Then ExitLoop
			If StringInStr(FileGetAttrib($sTargetDir & '\' & $sAppFolder), "D") Then $iNumberItems = $iNumberItems + 1
		WEnd
		FileClose($hSearch)

		$hSearch = FileFindFirstFile($sTargetDir & "\*.*")
		While 1
			$sAppFolder = FileFindNextFile($hSearch)
			If @error Then ExitLoop
			If StringInStr(FileGetAttrib($sTargetDir & '\' & $sAppFolder), "D") Then
				$K = $K + 1
				GUICtrlSetData($hProgressBar, (100 / $iNumberItems) * $K)
				If FileExists($sTargetDir & '\' & $sAppFolder & "\LupoApp.ini") And FileExists($sSourceDir & '\' & $sAppFolder) Then _Apps_ImportSettings($sSourceDir, $sAppFolder, $sTargetDir, $sAppFolder, 1)
			EndIf
		WEnd
		FileClose($hSearch)
	EndIf
	GUICtrlSetData($hProgressBar, 100)
EndFunc   ;==>_Import_Apps

Func _Import_MyFolders($sSourceDir, $sTargetDir, $hProgressBar)
	Local $hSearch, $sAppFolder, $iNumberItems = 0, $K = 0

	GUICtrlSetData($hProgressBar, 0)
	If FileExists($sTargetDir) = 0 Then DirCreate($sTargetDir)

	$hSearch = FileFindFirstFile($sSourceDir & "\*.*")
	While 1
		$sAppFolder = FileFindNextFile($hSearch)
		If @error Then ExitLoop
		$iNumberItems = $iNumberItems + 1
	WEnd
	FileClose($hSearch)

	$hSearch = FileFindFirstFile($sSourceDir & "\*.*")
	While 1
		$sAppFolder = FileFindNextFile($hSearch)
		If @error Then ExitLoop
		$K = $K + 1
		GUICtrlSetData($hProgressBar, (100 / $iNumberItems) * $K)
		If StringInStr(FileGetAttrib($sSourceDir & '\' & $sAppFolder), "D") Then
			DirCopy($sSourceDir & '\' & $sAppFolder, $sTargetDir & '\' & $sAppFolder, 1)
		Else
			FileCopy($sSourceDir & '\' & $sAppFolder, $sTargetDir & '\' & $sAppFolder, 1)
		EndIf
	WEnd
	FileClose($hSearch)
	GUICtrlSetData($hProgressBar, 100)
EndFunc   ;==>_Import_MyFolders

Func _Import_Skins($sSourceDir, $sTargetDir)
	Local $hSearch, $sFileName
	Local $sOldPath = $sSourceDir & "\Launcher\MenuThemes", $sNewPath = $sTargetDir & "\Launcher\MenuThemes"

	$hSearch = FileFindFirstFile($sOldPath & "\*.*")
	While 1
		$sFileName = FileFindNextFile($hSearch)
		If @error Then ExitLoop
		If StringInStr(FileGetAttrib($sOldPath & '\' & $sFileName), "D") Then DirCopy($sOldPath & '\' & $sFileName, $sNewPath & '\' & $sFileName)
	WEnd
	FileClose($hSearch)
EndFunc   ;==>_Import_Skins

Func _Importer($hMainGUI)
	Local $hGUI, $hProgressBar, $hOK, $hCancel, $hOldSearch, $hNewSearch, $sLanguage, $iDecision
	Local $hOldDir, $hNewDir, $sLoadedDir, $sSourceDir, $sTargetDir, $hStatusText, $aImportMode

	$hGUI = GUICreate("Import Settings", 330, 163, -1, -1, -1, $WS_EX_ACCEPTFILES, $hMainGUI)
	GUISetIcon(@ScriptFullPath, -6)
	GUISetBkColor(0x0A0A52)

	; create first input part
	GUICtrlCreateLabel("Drop here the folder of your previous Suite release:", 12, 12, 270, 18)
	GUICtrlSetColor(-1, 0xE5E5E5)
	$hOldDir = GUICtrlCreateInput("", 12, 28, 246, 20)
	GUICtrlSetState($hOldDir, $GUI_DROPACCEPTED)
	GUICtrlSetTip($hOldDir, 'The folder must contains "Lupo_PenSuite.exe"')
	$hOldSearch = GUICtrlCreateButton("Search", 262, 27, 58, 22)

	; create second input part
	GUICtrlCreateLabel("Drop here the folder of your new Suite release:", 12, 56, 270, 18)
	GUICtrlSetColor(-1, 0xE5E5E5)
	$hNewDir = GUICtrlCreateInput($Global_LupoDir, 12, 72, 246, 20)
	GUICtrlSetState($hNewDir, $GUI_DISABLE)
	GUICtrlSetTip($hNewDir, 'The folder must contains "Lupo_PenSuite.exe"')
	$hNewSearch = GUICtrlCreateButton("Change", 262, 71, 58, 22)

	; progressbar and buttons
	$hProgressBar = GUICtrlCreateProgress(12, 106, 306, 10)
	$hStatusText = GUICtrlCreateLabel(" ", 140, 133, 70, 18)
	GUICtrlSetColor($hStatusText, 0xE5E5E5)
	$hOK = GUICtrlCreateButton("OK", 165 - 80 - 30, 128, 80, 26)
	GUICtrlSetState($hOK, $GUI_FOCUS)
	$hCancel = GUICtrlCreateButton("Cancel", 165 + 30, 128, 80, 26)

	GUISetState()
	While 1
		Switch GUIGetMsg()
			Case $hCancel, $GUI_EVENT_CLOSE
				ExitLoop

			Case $hOldSearch
				$sLoadedDir = FileSelectFolder("Select folder of the previous Suite release:", "", 2)
				If $sLoadedDir <> "" Then GUICtrlSetData($hOldDir, $sLoadedDir)

			Case $hNewSearch
				$sLoadedDir = FileSelectFolder("Select folder of the new Suite release:", "", 2)
				If $sLoadedDir <> "" Then GUICtrlSetData($hNewDir, $sLoadedDir)
				GUICtrlSetState($hNewDir, $GUI_ENABLE)
				GUICtrlSetState($hNewDir, $GUI_DROPACCEPTED)
				GUICtrlSetData($hNewSearch, "Search")

			Case $hOK
				$sSourceDir = GUICtrlRead($hOldDir)
				$sTargetDir = GUICtrlRead($hNewDir)
				$Global_MyApps = $sSourceDir & "\MyApps"
				$Global_MyFiles = $sSourceDir & "\MyFiles"
				If $sSourceDir = "" Or $sTargetDir = "" Or $sSourceDir = $sTargetDir Or StringInStr($sSourceDir, '\') = 0 Or StringInStr($sTargetDir, '\') = 0 Or StringInStr(FileGetAttrib($sSourceDir), "D") = 0 Or StringInStr(FileGetAttrib($sTargetDir), "D") = 0 Or (FileExists($sSourceDir & "\Start.exe") = 0 And FileExists($sSourceDir & $Global_SuiteExe) = 0) Or (FileExists($sTargetDir & "\Start.exe") = 0 And FileExists($sTargetDir & $Global_SuiteExe) = 0) Then
					MsgBox(0, "Invalid Directories", "You have to select correct Suite directories." & @LF & "Please, check them and try again.")
				Else
					$aImportMode = _Import_Settings($hGUI, $sSourceDir)
					If $aImportMode[0] <> 0 Then
						; check if launcher is running
						If ProcessExists("ASuite.exe") Then
							MsgBox(0x40000, "Procedure interrupted", "Procedure not completable: a Suite launcher is still running." & @LF & "Please, close it and try again.")
						Else
							GUICtrlSetState($hOldDir, $GUI_DISABLE)
							GUICtrlSetState($hOldSearch, $GUI_DISABLE)
							GUICtrlSetState($hNewDir, $GUI_DISABLE)
							GUICtrlSetState($hNewSearch, $GUI_DISABLE)
							GUICtrlSetState($hOK, $GUI_DISABLE)
							GUICtrlSetState($hCancel, $GUI_DISABLE)
							MsgBox(0x40000, "Procedure alert", "During this procedure the window could seem blocked, but the process is correctly running. Please, wait the ending message.", 10)

							; run the import procedure
							If $aImportMode[1] = 1 Then
								If $Global_SuiteEdition = "Zero" Then
									GUICtrlSetData($hStatusText, "Menu...")
									_Copy_XML($sSourceDir, $sTargetDir)
								Else
									GUICtrlSetData($hStatusText, "Apps...")
									_Import_Apps($sSourceDir & "\Apps", $sTargetDir & "\Apps", $hProgressBar)
									GUICtrlSetData($hStatusText, "Extra...")
									_Import_Apps($sSourceDir & "\Apps\Extra", $sTargetDir & "\Apps\Extra", $hProgressBar)
									GUICtrlSetData($hStatusText, "Games...")
									_Import_Apps($sSourceDir & "\Apps\Games", $sTargetDir & "\Apps\Games", $hProgressBar)
								EndIf
								_Import_Skins($sSourceDir, $sTargetDir)
								$sLanguage = IniRead($sSourceDir & "\Launcher\Manager\config.ini", "General", "Language", "")
								If $sLanguage = "" Then $sLanguage = "English"
								IniWrite($sTargetDir & "\Launcher\Manager\config.ini", "General", "Language", $sLanguage)
							EndIf
							If $aImportMode[2] = 1 Then
								GUICtrlSetData($hStatusText, "MyApps...")
								_Import_MyFolders($Global_MyApps, $sTargetDir & "\MyApps", $hProgressBar)
								If $Global_SuiteEdition <> "Zero" Then _Import_XML($sSourceDir, $sTargetDir)
							EndIf
							If $aImportMode[3] = 1 Then
								GUICtrlSetData($hStatusText, "MyFiles...")
								_Import_MyFolders($Global_MyFiles, $sTargetDir & "\MyFiles", $hProgressBar)
							EndIf
							GUICtrlSetData($hProgressBar, 100)
							GUICtrlSetData($hStatusText, " ")

							; end process message
							$iDecision = MsgBox(0x40004, "Import finished!", "You have successfully imported your previous Suite settings." & @LF & "Do you want to start the Suite menu now?")
							If $iDecision = 6 Then
								Run($Global_LupoDir & $Global_SuiteExe)
								Exit
							Else
								ExitLoop
							EndIf
						EndIf
					EndIf
				EndIf

		EndSwitch
	WEnd

	GUIDelete($hGUI)
EndFunc   ;==>_Importer

Func _Switcher($hMainGUI)
	Local $hGUI, $hOK, $hCancel, $hMsg, $hCustom, $iDecision, $iCurrent, $hIcon[14][12], $hRadio[14], $hBorder[14], $sIconDir = @ScriptDir & "\Data\sets\Set"

	$hGUI = GUICreate("Switch Icon-Sets", 432, 318, -1, -1, -1, -1, $hMainGUI)
	GUISetIcon(@ScriptFullPath, -7)
	GUISetBkColor(0x0A0A52)

	GUICtrlCreateLabel("Select the Icon-Set you want to use:", 50, 10, 260, 16)
	GUICtrlSetColor(-1, 0xE5E5E5)

	For $K = 1 To 13
		$hRadio[$K] = GUICtrlCreateRadio("", $K * 32 - 14, 26, 23, 20)
		GUICtrlSetColor($hRadio[$K], 0xE5E5E5)
		$hIcon[$K][1] = GUICtrlCreateIcon($sIconDir & $K & "\11.ico", -1, $K * 32 - 16, 40 + 12, 16, 16)
		$hIcon[$K][2] = GUICtrlCreateIcon($sIconDir & $K & "\22.ico", -1, $K * 32 - 16, 60 + 12, 16, 16)
		$hIcon[$K][3] = GUICtrlCreateIcon($sIconDir & $K & "\33.ico", -1, $K * 32 - 16, 80 + 12, 16, 16)
		$hIcon[$K][4] = GUICtrlCreateIcon($sIconDir & $K & "\44.ico", -1, $K * 32 - 16, 100 + 12, 16, 16)
		$hIcon[$K][5] = GUICtrlCreateIcon($sIconDir & $K & "\55.ico", -1, $K * 32 - 16, 120 + 12, 16, 16)
		$hIcon[$K][6] = GUICtrlCreateIcon($sIconDir & $K & "\66.ico", -1, $K * 32 - 16, 140 + 12, 16, 16)
		$hIcon[$K][7] = GUICtrlCreateIcon($sIconDir & $K & "\77.ico", -1, $K * 32 - 16, 160 + 12, 16, 16)
		$hIcon[$K][11] = GUICtrlCreateIcon($sIconDir & $K & "\my.ico", -1, $K * 32 - 16, 180 + 18, 16, 16)
		$hIcon[$K][8] = GUICtrlCreateIcon($sIconDir & $K & "\88.ico", -1, $K * 32 - 16, 200 + 18, 16, 16)
		$hIcon[$K][9] = GUICtrlCreateIcon($sIconDir & $K & "\99.ico", -1, $K * 32 - 16, 220 + 18, 16, 16)
		$hIcon[$K][10] = GUICtrlCreateIcon($sIconDir & $K & "\folder.ico", -1, $K * 32 - 16, 240 + 18, 16, 16)
		$hBorder[$K] = GUICtrlCreateGraphic($K * 32 - 22, 46, 27, 233, 0)
		GUICtrlSetColor($hBorder[$K], 0x1F2198)
	Next

	$iCurrent = IniRead($Global_INI, "Switcher", "IconSet", "5")
	GUICtrlSetState($hRadio[$iCurrent], $GUI_CHECKED)
	GUICtrlSetColor($hBorder[$iCurrent], 0x74ADFF)

	$hCustom = GUICtrlCreateButton("Custom", 216 - 70 - 110, 285, 70, 24)
	GUICtrlSetTip(-1, "How to load a custom Icon-Set")
	$hOK = GUICtrlCreateButton("OK", 216 - 40, 285, 80, 26)
	$hCancel = GUICtrlCreateButton("Cancel", 216 + 110, 286, 70, 24)
	GUICtrlSetState($hOK, $GUI_FOCUS)

	GUISetState()
	While 1
		$hMsg = GUIGetMsg()
		Switch $hMsg
			Case $hCancel, $GUI_EVENT_CLOSE
				ExitLoop

			Case $hOK
				For $K = 1 To 13
					If GUICtrlRead($hRadio[$K]) = $GUI_CHECKED Then
						IniWrite($Global_INI, "Switcher", "IconSet", $K)
						FileCopy($sIconDir & $K & '\', $Global_LupoDir & "\Launcher\Icons\Set\", 9)
					EndIf
				Next
				MsgBox(0x40000, "Restart the Suite", "These changes will be active at the next Suite startup.")
				ExitLoop

			Case $hCustom
				$iDecision = MsgBox(0x00004, "Custom Icon-Set", 'If you want to use a custom Icon-Set, you can manually change icons' & @LF & 'in "[Suite]\Launcher\Icons\Set". Do you want to open this folder?')
				If $iDecision = 6 Then ShellExecute($Global_LupoDir & "\Launcher\Icons\Set")

			Case Else
				If $hMsg >= $hIcon[1][1] And $hMsg <= $hIcon[13][11] Then
					For $K = 1 To 13
						For $J = 1 To 11
							If $hMsg = $hIcon[$K][$J] Then
								GUICtrlSetState($hRadio[$iCurrent], $GUI_UNCHECKED)
								GUICtrlSetState($hRadio[$K], $GUI_CHECKED)
								ExitLoop 2
							EndIf
						Next
					Next
				EndIf
				If $hMsg >= $hRadio[1] And $hMsg <= $hRadio[13] Then
					For $K = 1 To 13
						If GUICtrlRead($hRadio[$K]) = $GUI_CHECKED Then
							GUICtrlSetColor($hBorder[$K], 0x74ADFF)
							GUICtrlSetColor($hBorder[$iCurrent], 0x1F2198)
							$iCurrent = $K
							ExitLoop
						EndIf
					Next
				EndIf

		EndSwitch
	WEnd

	GUIDelete($hGUI)
EndFunc   ;==>_Switcher

Func _Guide()
	Local $hGUI, $oIE = _IECreateEmbedded()

	$hGUI = GUICreate("Lupo Guide", 600, 450, -1, -1, -1)
	GUISetIcon(@ScriptFullPath, -10)
	GUICtrlCreateObj($oIE, -1, -1, 602, 452)
	GUISetState()
	_IENavigate($oIE, @ScriptDir & "\Data\guide\index.htm")

	While 1
		If GUIGetMsg() = $GUI_EVENT_CLOSE Then ExitLoop
	WEnd

	GUIDelete($hGUI)
EndFunc   ;==>_Guide

Func _Apps_Find($hImage, $sAppsDir, $sAppType)
	Local $hSearch, $iItem, $sAppINI, $sAppFolder, $sAppIcon, $sAppVersion, $sAppPath, $sSkipList = IniRead($Global_INI, "SkipList", "ToSkip", "")

	If FileExists($sAppsDir) Then
		$hSearch = FileFindFirstFile($sAppsDir & "\*.*")
		While 1
			$sAppFolder = FileFindNextFile($hSearch)
			If @error Then ExitLoop
			If StringInStr(FileGetAttrib($sAppsDir & '\' & $sAppFolder), "D") Then
				$sAppINI = $sAppsDir & '\' & $sAppFolder & "\LupoApp.ini"
				If FileExists($sAppINI) Then
					If $hImage = -1 Then
						$iItem = _GUICtrlListView_AddItem($Global_ListView, IniRead($sAppINI, "Software", "Name", $sAppFolder))
					Else
						$sAppPath = $sAppsDir & '\' & $sAppFolder & '\' & IniRead($sAppINI, "Software", "Main", "000")
						If StringRight($sAppPath, 4) <> ".exe" Then
							$sAppPath = $sAppsDir & '\' & $sAppFolder & '\' & IniRead($sAppINI, "Software", "Name", "000") & ".exe"
							If FileExists($sAppPath) = 0 Then $sAppPath = $sAppsDir & '\' & $sAppFolder & '\' & $sAppFolder & ".exe"
						EndIf
						If FileExists($sAppPath) = 0 Then
							$sAppIcon = __GUIImageList_AddIcon($hImage, @ScriptFullPath, 10)
						Else
							$sAppIcon = __GUIImageList_AddIcon($hImage, $sAppPath)
							If $sAppIcon = -1 Then $sAppIcon = __GUIImageList_AddIcon($hImage, StringTrimRight($sAppPath, 3) & "ico")
							If $sAppIcon = -1 Then $sAppIcon =  __GUIImageList_AddIcon($hImage, @ScriptFullPath, 10)
						EndIf
						$iItem = _GUICtrlListView_AddItem($Global_ListView, IniRead($sAppINI, "Software", "Name", $sAppFolder), $sAppIcon)
					EndIf
					_GUICtrlListView_AddSubItem($Global_ListView, $iItem, IniRead($sAppINI, "Software", "Version", " ? "), 1)
					If StringInStr($sSkipList, "|" & _GUICtrlListView_GetItemText($Global_ListView, $iItem, 0) & "|") Then
						_GUICtrlListView_AddSubItem($Global_ListView, $iItem, "Skip it", 2)
					Else
						_GUICtrlListView_AddSubItem($Global_ListView, $iItem, " - ", 2)
					EndIf
					_GUICtrlListView_AddSubItem($Global_ListView, $iItem, " - ", 3)
					_GUICtrlListView_AddSubItem($Global_ListView, $iItem, $sAppType, 4)
					$iItem = _GUICtrlListView_AddItem($Global_ListViewHidden, $sAppFolder)
					_GUICtrlListView_AddSubItem($Global_ListViewHidden, $iItem, IniRead($sAppINI, "Software", "Description", "Not Available"), 1)
					_GUICtrlListView_AddSubItem($Global_ListViewHidden, $iItem, "Internal", 2)
				ElseIf $sAppFolder <> "Extra" And $sAppFolder <> "Games" Then
					$sAppINI = $sAppsDir & '\' & $sAppFolder & "\App\AppInfo\appinfo.ini"
					If $hImage = -1 Then
						If FileExists($sAppINI) Then
							$iItem = _GUICtrlListView_AddItem($Global_ListView, IniRead($sAppINI, "Details", "Name", $sAppFolder))
						Else
							$iItem = _GUICtrlListView_AddItem($Global_ListView, $sAppFolder)
						EndIf
					Else
						$sAppPath = $sAppsDir & '\' & $sAppFolder & '\' & $sAppFolder & ".exe"
						If FileExists($sAppPath) = 0 Then
							$sAppIcon = __GUIImageList_AddIcon($hImage, @ScriptFullPath, 10)
						Else
							$sAppIcon = __GUIImageList_AddIcon($hImage, $sAppPath)
							If $sAppIcon = -1 Then $sAppIcon = __GUIImageList_AddIcon($hImage, StringTrimRight($sAppPath, 3) & "ico")
							If $sAppIcon = -1 Then $sAppIcon =  __GUIImageList_AddIcon($hImage, @ScriptFullPath, 10)
						EndIf
						If FileExists($sAppINI) Then
							$iItem = _GUICtrlListView_AddItem($Global_ListView, IniRead($sAppINI, "Details", "Name", $sAppFolder), $sAppIcon)
						Else
							$iItem = _GUICtrlListView_AddItem($Global_ListView, $sAppFolder, $sAppIcon)
						EndIf
					EndIf
					If FileExists($sAppINI) Then
						_GUICtrlListView_AddSubItem($Global_ListView, $iItem, IniRead($sAppINI, "Version", "DisplayVersion", " ? "), 1)
					Else
						$sAppVersion = FileGetVersion($sAppPath)
						If $sAppVersion = "0.0.0.0" Or $sAppVersion = "" Or StringInStr($sAppPath, "portable.exe") Then
							_GUICtrlListView_AddSubItem($Global_ListView, $iItem, " ? ", 1)
						Else
							_GUICtrlListView_AddSubItem($Global_ListView, $iItem, $sAppVersion, 1)
						EndIf
					EndIf
					If StringInStr($sSkipList, "|" & _GUICtrlListView_GetItemText($Global_ListView, $iItem, 0) & "|") Then
						_GUICtrlListView_AddSubItem($Global_ListView, $iItem, "Skip it", 2)
					Else
						_GUICtrlListView_AddSubItem($Global_ListView, $iItem, " - ", 2)
					EndIf
					_GUICtrlListView_AddSubItem($Global_ListView, $iItem, " - ", 3)
					_GUICtrlListView_AddSubItem($Global_ListView, $iItem, $sAppType, 4)
					$iItem = _GUICtrlListView_AddItem($Global_ListViewHidden, $sAppFolder)
					If FileExists($sAppINI) Then
						_GUICtrlListView_AddSubItem($Global_ListViewHidden, $iItem, IniRead($sAppINI, "Details", "Description", "Not Available"), 1)
						_GUICtrlListView_AddSubItem($Global_ListViewHidden, $iItem, IniRead($sAppINI, "Details", "Homepage", "Unknown"), 2)
					Else
						_GUICtrlListView_AddSubItem($Global_ListViewHidden, $iItem, "Not Available", 1)
						_GUICtrlListView_AddSubItem($Global_ListViewHidden, $iItem, "Unknown", 2)
					EndIf
				EndIf
			EndIf
		WEnd
		FileClose($hSearch)
	EndIf

	Return $hImage
EndFunc   ;==>_Apps_Find

Func _Apps_Check($hClose, $hProgressBar, $iHide)
	Local $sName, $sNewName, $sVersion, $sNewVersion, $sResult, $sNewResult, $iSize, $iNewSize, $sDownloadLink, $sPageLink
	Local $aArray, $sString, $hDownload, $fOnlyEnglish, $fInternal, $hFileOpen, $sLine, $sPageFile, $iNumberItems = 1, $sPageFilePA = "pa.htm"
	If $iHide < 0 Then $iNumberItems = _GUICtrlListView_GetItemCount($Global_ListView)

	For $K = 0 To $iNumberItems - 1
		If $iHide = -1 And GUIGetMsg() = $hClose Then Return -1
		If $iHide >= 0 Then $K = $iHide
		_GUICtrlListView_SetItemChecked($Global_ListView, $K, False)
		$sName = _GUICtrlListView_GetItemText($Global_ListView, $K, 0)
		$sVersion = _GUICtrlListView_GetItemText($Global_ListView, $K, 1)
		$sResult = _GUICtrlListView_GetItemText($Global_ListView, $K, 2)
		$sDownloadLink = ""
		If $sResult = "Skip it" And $iHide < 0 Then
			$sNewResult = "Skipped"
			$iNewSize = "N.A."
		Else
			$fInternal = 0
			$fOnlyEnglish = 0
			$sPageFile = StringLower(StringReplace(StringReplace($sName, "!", ""), " ", "")) & ".htm"
			$hDownload = InetGet($Global_Site & "db/" & $sPageFile, $sPageFile, 1)
			If InetGetInfo($hDownload, 4) <> 0 Then FileDelete($sPageFile)
			If FileExists($sPageFile) = 0 Then
				$sPageLink = StringLower(_GUICtrlListView_GetItemText($Global_ListViewHidden, $K, 2))
				If StringInStr($sPageLink, "portableapps.com") Then
					$sPageFile = $sPageFilePA
					$hDownload = InetGet("http://" & $sPageLink, $sPageFile, 1)
					If InetGetInfo($hDownload, 4) <> 0 Then FileDelete($sPageFile)
				EndIf
			EndIf
			If FileExists($sPageFile) Then
				$hFileOpen = FileOpen($sPageFile, 0)
				If $sPageFile = $sPageFilePA Then ; PortableApps.com Software.
					$sLine = FileReadLine($hFileOpen, 120)
					While 1
						$sLine = FileReadLine($hFileOpen)
						If @error = -1 Then ExitLoop
						If StringInStr($sLine, "<h1>") Then
							$aArray = StringRegExp($sLine, '<h1>(.*?)</h1>', 3)
							$sNewName = $aArray[0]
						EndIf
						If StringInStr($sLine, 'class="download-box"') Then
							$aArray = StringRegExp($sLine, 'href="(.*?)">', 3)
							$sDownloadLink = $aArray[0]
							$sDownloadLink = StringReplace($sDownloadLink, "%3A", ":")
							$sDownloadLink = StringReplace($sDownloadLink, "%2F", "/")
							If StringInStr($sDownloadLink, '?') Then
								While 1
									If StringLeft($sDownloadLink, 4) = 'http' Then
										ExitLoop
									Else
										$sDownloadLink = StringTrimLeft($sDownloadLink, 1)
									EndIf
									If StringLen($sDownloadLink) < 6 Then ExitLoop
								WEnd
								While 1
									If StringRight($sDownloadLink, 1) = '?' Then
										$sDownloadLink = StringTrimRight($sDownloadLink, 1)
										ExitLoop
									Else
										$sDownloadLink = StringTrimRight($sDownloadLink, 1)
									EndIf
									If StringLen($sDownloadLink) < 6 Then ExitLoop
								WEnd
								If StringLen($sDownloadLink) < 6 Then $sDownloadLink = $aArray[0]
							EndIf
							$aArray = StringRegExp($sLine, '<strong>Download (.*?)</strong>', 3)
							$sNewVersion = "N.A."
							$iSize = "N.A."
							If @Error = 0 Then
								If StringInStr($aArray[0], ".") Then $sNewVersion = $aArray[0]
							EndIf
							ExitLoop
						EndIf
					Wend
				Else ; LupoPenSuite.com Software.
					$sLine = FileReadLine($hFileOpen, 15)
					While 1
						$sLine = FileReadLine($hFileOpen)
						If @error = -1 Then ExitLoop
						If StringInStr($sLine, "<h3>") Then
							$aArray = StringRegExp($sLine, '>(.*?)<', 3)
							$sString = StringTrimLeft($aArray[1], 1)
							If StringInStr($sString, "(") Then
								$aArray = StringRegExp($sString, '\(v(.*?)\)', 3)
								$sNewVersion = $aArray[0]
								$sNewName = StringTrimRight($sString, StringLen($sNewVersion) + 4)
							Else
								$sNewVersion = "1.0"
								$sNewName = $sString
							EndIf
						EndIf
						If StringInStr($sLine, "d5.gif") Then
							$aArray = StringRegExp($sLine, 'href="(.*?)">', 3)
							$sDownloadLink = $aArray[0]
							If StringInStr($sDownloadLink, "../") Then $sDownloadLink = StringReplace($sDownloadLink, "../", $Global_Site)
						EndIf
						If StringInStr($sLine, "/sin/") Then $fInternal = 1
						If StringInStr($sLine, 'class="dwl"') Then $fOnlyEnglish = 1
						If StringInStr($sLine, "MB</div>") Then
							$iSize = StringReplace(StringTrimRight($sLine, 6), " MB / ", "/")
							ExitLoop
						EndIf
					Wend
				EndIf
				FileClose($hFileOpen)
				FileDelete($sPageFile)
				If $sName = $sNewName And $sNewVersion <> "N.A." Then
					If $sVersion = $sNewVersion And $iHide < 0 Then
						$sNewResult = "OK"
					Else
						If $fInternal = 1 Then
							$sNewResult = $sNewVersion
							If $fOnlyEnglish = 1 Then $sNewResult = $sNewVersion & " *English"
							_GUICtrlListView_SetItemChecked($Global_ListView, $K)
						Else
							$sNewResult = $sNewVersion & " *manual update"
						EndIf
					EndIf
					$iNewSize = $iSize
				Else
					$sNewResult = "N.A."
					$iNewSize = "N.A."
				EndIf
			Else
				$sNewResult = "N.A."
				$iNewSize = "N.A."
			EndIf
		EndIf
		_GUICtrlListView_SetItemText($Global_ListView, $K, $sNewResult, 2)
		_GUICtrlListView_SetItemText($Global_ListView, $K, $iNewSize, 3)
		_GUICtrlListView_AddSubItem($Global_ListViewHidden, $K, $sDownloadLink, 4)
		_GUICtrlListView_EnsureVisible($Global_ListView, $K)
		GUICtrlSetData($hProgressBar, (100 / $iNumberItems) * ($K + 1))
	Next

	Return 0
EndFunc   ;==>_Apps_Check

Func _Apps_Update($sLupoTempDir, $iDecision, $hClose, $hProgressBar, $iHide)
	Local $sLine, $hInputOpen, $hOutputOpen, $sAppName, $sAppFolder, $sAppType, $sAppExe, $sAppPath, $sNewAppPath
	Local $fState, $sNewVersion, $sAppsDir, $sNewAppsTempDir, $sOldAppsTempDir, $sDownloadLink, $hDownload
	Local $sXML, $sOldPath, $sNewPath, $iNumberItems = 1, $iCount = 0, $iChecked = 0

	If $iHide < 0 Then
		$iNumberItems = _GUICtrlListView_GetItemCount($Global_ListView)
		For $K = 0 To $iNumberItems - 1
			If _GUICtrlListView_GetItemChecked($Global_ListView, $K) Then $iChecked = $iChecked + 1
		Next
	Else
		$iChecked = 1
	EndIf

	For $K = 0 To $iNumberItems - 1
		If $iHide = -1 And GUIGetMsg() = $hClose Then Return -1
		If $iHide >= 0 Then $K = $iHide
		$fState = _GUICtrlListView_GetItemChecked($Global_ListView, $K)
		If $fState = "true" Then
			If $iDecision = 0 Then $iDecision = MsgBox(0x00004, "Update selected apps", "Important: close all portable software that will be updated." & @LF & "Do you want to start the update process now?")
			If $iDecision = 6 Then
				_GUICtrlListView_SetItemChecked($Global_ListView, $K, False)
				_GUICtrlListView_EnsureVisible($Global_ListView, $K)
				$sNewVersion = _GUICtrlListView_GetItemText($Global_ListView, $K, 2)
				If $sNewVersion = "OK" Or $sNewVersion = "Skip it" Or $sNewVersion = "Skipped" Or StringInStr($sNewVersion, "N.A.") Then
					_GUICtrlListView_SetItemText($Global_ListView, $K, " X ", 2)
				ElseIf StringInStr($sNewVersion, "*manual") Then
					_GUICtrlListView_SetItemText($Global_ListView, $K, "N.A.", 2)
				ElseIf $sNewVersion = "Done!" Then
					_GUICtrlListView_SetItemText($Global_ListView, $K, "OK", 2)
				ElseIf $sNewVersion <> " X " Then
					$sNewVersion = StringReplace($sNewVersion, " *English", "")
					$sAppName = _GUICtrlListView_GetItemText($Global_ListView, $K, 0)
					$sAppFolder = _GUICtrlListView_GetItemText($Global_ListViewHidden, $K, 0)
					$sDownloadLink = _GUICtrlListView_GetItemText($Global_ListViewHidden, $K, 4)
					$sAppType = _GUICtrlListView_GetItemText($Global_ListView, $K, 4)
					$sNewAppsTempDir = $sLupoTempDir & "\NewApps"
					$sOldAppsTempDir = $sLupoTempDir & "\OldApps"
					$sAppsDir = _Get_AppsDir($sAppType)

					; check if the application is in use
					$sAppPath = IniRead($sAppsDir & "\" & $sAppFolder & "\LupoApp.ini", "Software", "Main", $sAppName & ".exe")
					If ProcessExists($sAppPath) Then MsgBox(0x40000, "Software in use", $sAppName & " is running. Close it now and then click OK for a correct update, otherwise it will be skipped.")
					If ProcessExists($sAppPath) Then
						_GUICtrlListView_SetItemText($Global_ListView, $K, "Skipped", 2)
					Else
						; download software in "LupoTemp\NewApps"
						$sAppExe = StringReplace($sAppName, " ", "_") & ".exe"
						If FileExists($sNewAppsTempDir) = 0 Then DirCreate($sNewAppsTempDir)
						If $sDownloadLink = "" Then $sDownloadLink = $Global_Site & "downloads/sin/" & $sAppExe
						$hDownload = InetGet($sDownloadLink, $sNewAppsTempDir & "\" & $sAppExe, 1)
						If InetGetInfo($hDownload, 4) <> 0 Then
							FileDelete($sNewAppsTempDir & "\" & $sAppExe)
							_GUICtrlListView_SetItemText($Global_ListView, $K, "Failed", 2)
						Else
							If FileExists($sNewAppsTempDir & "\" & $sAppName) Then DirRemove($sNewAppsTempDir & "\" & $sAppName, 1)
							RunWait($sNewAppsTempDir & "\" & $sAppExe & " -s -y -ai", "", @SW_HIDE) ; program extraction
							_Apps_ImportSettings($sAppsDir, $sAppFolder, $sNewAppsTempDir, $sAppName, 1)
							If $sAppName <> $sAppFolder Then DirMove($sNewAppsTempDir & "\" & $sAppName, $sNewAppsTempDir & "\" & $sAppFolder, 1) ; fix folder name of new version
							If FileExists($sNewAppsTempDir & "\" & $sAppFolder & "\LupoApp.ini") = 0 Then
								; remove files of failed update
								DirRemove($sNewAppsTempDir & "\" & $sAppFolder, 1)
								FileDelete($sNewAppsTempDir & "\" & $sAppExe)
								_GUICtrlListView_SetItemText($Global_ListView, $K, "Failed", 2)
							Else
								; move old software in "LupoTemp\OldApps" or remove it
								If IniRead($Global_INI, "General", "UpdateMode", "Keep") = "Keep" Then
									If FileExists($sOldAppsTempDir) = 0 Then DirCreate($sOldAppsTempDir)
									If FileExists($sOldAppsTempDir & "\" & $sAppFolder) Then DirRemove($sOldAppsTempDir & "\" & $sAppFolder, 1) ; keep only the last old version
									DirMove($sAppsDir & "\" & $sAppFolder, $sOldAppsTempDir & "\" & $sAppFolder, 1)
								Else
									DirRemove($sAppsDir & "\" & $sAppFolder, 1)
								EndIf
								FileDelete($sNewAppsTempDir & "\" & $sAppExe)

								; move new software in "Apps"
								DirMove($sNewAppsTempDir & "\" & $sAppFolder, $sAppsDir & "\" & $sAppFolder, 1)

								; update the software path in the Suite menu if is changed
								$sNewAppPath = IniRead($sAppsDir & "\" & $sAppFolder & "\LupoApp.ini", "Software", "Main", $sAppName & ".exe")
								If $sNewAppPath <> $sAppPath And FileExists($sAppsDir & "\" & $sAppFolder & "\" & $sNewAppPath) Then
									If ProcessExists("ASuite.exe") Then MsgBox(0x40000, "Alert message", 'Close the main Suite launcher and than click "OK", otherwise you will need to manually fix the menu link of "' & $sAppName & '" later.')
									Sleep(600)
									$sXML = $Global_LupoDir & "\Launcher\ASuite.xml"
									$sOldPath = StringTrimLeft($sAppsDir & "\" & $sAppFolder & "\" & $sAppPath, StringLen($Global_LupoDir) + 1)
									$sNewPath = StringTrimLeft($sAppsDir & "\" & $sAppFolder & "\" & $sNewAppPath, StringLen($Global_LupoDir) + 1)
									$hInputOpen = FileOpen($sXML, 0)
									$hOutputOpen = FileOpen($Global_TempFile, 2)
									While 1
									$sLine = FileReadLine($hInputOpen)
										If @error = -1 Then ExitLoop
										If StringInStr($sLine, $sOldPath) Then $sLine = StringReplace($sLine, $sOldPath, $sNewPath)
										FileWriteLine($hOutputOpen, $sLine)
									WEnd
									FileClose($hInputOpen)
									FileClose($hOutputOpen)
									FileCopy($Global_TempFile, $sXML, 1)
									FileDelete($Global_TempFile)
								EndIf
								If $sNewVersion = "Failed" Then $sNewVersion = IniRead($sAppsDir & "\" & $sAppFolder & "\LupoApp.ini", "Software", "Version", _GUICtrlListView_GetItemText($Global_ListView, $K, 1))
								_GUICtrlListView_SetItemText($Global_ListView, $K, $sNewVersion, 1)
								_GUICtrlListView_SetItemText($Global_ListView, $K, "Done!", 2)
							EndIf
						EndIf
					EndIf
				EndIf
				$iCount = $iCount + 1
				GUICtrlSetData($hProgressBar, (100 / $iChecked) * $iCount)
			Else
				Return -2
			EndIf
		EndIf
	Next

	Return 0
EndFunc   ;==>_Apps_Update

Func _Apps_ImportSettings_Config($hParentGUI, $iItem)
	Local $hGUI, $hImport, $hCancel, $hImportField, $hSearch, $hInfo, $sOldAppsDir, $sOldAppFolder, $sAppsDir, $sAppFolder, $sAppType
	Local $sString, $aArray, $iDecision, $iReturnValue = 1

	$hGUI = GUICreate("Manual Import Settings", 320, 132, -1, -1, -1, BitOr($WS_EX_ACCEPTFILES, $WS_EX_TOOLWINDOW), $hParentGUI)

	GUICtrlCreateLabel('Important: read the "Info" message to know how it works.', 13, 10, 300)
	GUICtrlSetFont(-1, -1, 400, 4)

	GUICtrlCreateGroup("Select the external program folder where bring settings:", 9, 37, 302, 53)
	$hImportField = GUICtrlCreateInput("", 19, 58, 219, 20)
	GUICtrlSetState($hImportField, $GUI_DROPACCEPTED)
	GUICtrlSetTip($hImportField, "It must be the program main folder, not its settings subfolder.")
	$hSearch = GUICtrlCreateButton("Search", 243, 57, 58, 22)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	$hInfo = GUICtrlCreateButton("Info", 160 - 70 - 74, 100, 70, 24)
	$hImport = GUICtrlCreateButton("Import", 160 - 40, 99, 80, 26)
	GUICtrlSetTip(-1, "Start to import settings from the selected folder")
	$hCancel = GUICtrlCreateButton("Cancel", 160 + 74, 100, 70, 24)

	$sAppFolder = _GUICtrlListView_GetItemText($Global_ListViewHidden, $iItem, 0)
	$sAppType = _GUICtrlListView_GetItemText($Global_ListView, $iItem, 4)
	$sAppsDir = _Get_AppsDir($sAppType)

	GUISetState()
	While 1
		Switch GUIGetMsg()
			Case $hSearch
				$sString = FileSelectFolder("Select the external program folder:", "", 2)
				If $sString <> "" Then GUICtrlSetData($hImportField, $sString)

			Case $hInfo
				MsgBox(0, "Info", 'This feature allows to import settings for the selected software from an external application folder. You only needs to select the main folder of the external program from which you want to bring settings and click "Import".' & @LF & @LF & 'Note: this process starts removing previous settings. An alert will report you if it can not recognise setting structure. In this case ensure that external folder correctely contains them, otherwise you could lost some configurations.')

			Case $hImport
				$sString = GUICtrlRead($hImportField)
				If StringInStr(FileGetAttrib($sString), "D") Then
					$iDecision = 6
					If FileExists($sString & "\LupoApp.ini") = 0 And FileExists($sString & "\Data") = 0 Then
						$iDecision = MsgBox(0x00004, "Alert message", "The selected folder does not contain a known setting structure. Import will work fine if settings are really stored in it, otherwise you could lost some configurations. Are you sure to continue?")
					EndIf
					If $iDecision = 6 Then
						$aArray = StringSplit($sString, '\', 1)
						$sOldAppFolder = $aArray[$aArray[0]]
						$sOldAppsDir = StringTrimRight($sString, StringLen($sOldAppFolder) + 1)
						If _Apps_ImportSettings($sOldAppsDir, $sOldAppFolder, $sAppsDir, $sAppFolder, 1) = 0 Then $iReturnValue = -1
						ExitLoop
					EndIf
				Else
					MsgBox(0, "Folder not found", "You have to select an existent folder to import settings.")
				EndIf

			Case $hCancel, $GUI_EVENT_CLOSE
				$iReturnValue = 0
				ExitLoop

		EndSwitch
	WEnd

	GUIDelete($hGUI)
	Return $iReturnValue
EndFunc   ;==>_Apps_ImportSettings_Config

Func _Apps_ImportSettings($sOldAppsDir, $sOldAppFolder, $sAppsDir, $sAppFolder, $iMode)
	Local $sReadFile, $sString, $fImportAll, $fState = 0, $K = 1
	Local $sOldPath = $sOldAppsDir & '\' & $sOldAppFolder, $sNewPath = $sAppsDir & '\' & $sAppFolder
	Local $sNewPathTemp = $sAppsDir & "\$" & $sAppFolder, $sAppINI = $sNewPath & "\LupoApp.ini"

	If FileExists($sAppINI) Then
		While $fState = 0
			$sReadFile = IniRead($sAppINI, "Settings", "Item" & $K, "0")
			If $sReadFile = "0" Then
				$fState = 1
			ElseIf StringInStr($sReadFile, "$$") Then
				$K = $K + 1
				$fImportAll = 1
				$sString = "\" & StringTrimLeft($sReadFile, 2)
				If $iMode = 1 Then
					If StringInStr(FileGetAttrib($sOldPath & $sString), "D") Then
						DirCopy($sOldPath & $sString, $sNewPathTemp & $sString, 1)
						DirRemove($sOldPath & $sString, 1)
					Else
						FileCopy($sOldPath & $sString, $sNewPathTemp & $sString, 9)
						FileDelete($sOldPath & $sString)
					EndIf
				Else
					If StringInStr(FileGetAttrib($sNewPath & $sString), "D") Then
						DirCopy($sNewPath & $sString, $sOldPath & $sString, 1)
					Else
						FileCopy($sNewPath & $sString, $sOldPath & $sString, 9)
					EndIf
				EndIf
			Else
				$K = $K + 1
				$sString = "\" & $sReadFile
				If StringInStr(FileGetAttrib($sOldPath & $sString), "D") Then
					DirRemove($sNewPath & $sString, 1)
					DirCopy($sOldPath & $sString, $sNewPath & $sString, 1)
				Else
					FileDelete($sNewPath & $sString)
					FileCopy($sOldPath & $sString, $sNewPath & $sString, 9)
				EndIf
			EndIf
		WEnd
		If $fImportAll = 1 Then
			If $iMode = 1 Then
				DirCopy($sOldPath, $sNewPath, 1)
				DirCopy($sNewPathTemp, $sOldPath, 1)
				DirRemove($sNewPathTemp, 1)
			Else
				DirRemove($sNewPath, 1)
				DirCopy($sOldPath, $sNewPath, 1)
				DirRemove($sOldPath, 1)
			EndIf
		EndIf
	ElseIf FileExists($sOldPath & "\Data") Then
		DirRemove($sNewPath & "\Data", 1)
		DirCopy($sOldPath & "\Data", $sNewPath & "\Data", 1)
	Else
		Return 0
	EndIf
EndFunc   ;==>_Apps_ImportSettings

Func _Apps_Backup_Config($hParentGUI, $iChecked)
	Local $hGUI, $hPlace, $hBackup, $hCancel, $iReturnValue, $sBackupDir, $sString, $aImport[4]

	$hGUI = GUICreate("Create Backup", 320, 182, -1, -1, -1, $WS_EX_TOOLWINDOW, $hParentGUI)

	GUICtrlCreateLabel("Important: close all portable software that will be backupped.", 13, 10, 300)
	GUICtrlSetFont(-1, -1, 400, 4)

	GUICtrlCreateGroup("What apps do you want to backup?", 9, 36, 302, 47)
	$aImport[0] = GUICtrlCreateRadio("Only selected apps", 24, 53, 130, 20)
	$aImport[1] = GUICtrlCreateRadio("All listed apps", 165, 53, 130, 20)
	GUICtrlSetState($aImport[0], 1)
	If $iChecked = 0 Then
		GUICtrlSetState($aImport[1], 1)
		GUICtrlSetState($aImport[0], $GUI_DISABLE)
	EndIf
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("What components do you what to backup?", 9, 92, 302, 47)
	$aImport[2] = GUICtrlCreateRadio("Settings only (faster)", 24, 109, 130, 20)
	GUICtrlSetTip($aImport[2], "It works only with supported apps")
	$aImport[3] = GUICtrlCreateRadio("Complete apps (slower)", 165, 109, 130, 20)
	GUICtrlSetState($aImport[2], 1)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	$sBackupDir = IniRead($Global_INI, "General", "BackupDir", "")
	If $sBackupDir = "" Then $sBackupDir = "..\..\MyFiles\Backups"
	$hPlace = GUICtrlCreateButton("Place", 160 - 70 - 74, 150, 70, 24)
	GUICtrlSetTip(-1, "You can change the main directory where place backup folders")
	$hBackup = GUICtrlCreateButton("Backup", 160 - 40, 149, 80, 26)
	GUICtrlSetTip(-1, "Start to backup apps in " & '"' & $Global_BackupFolder & '"' & " folder")
	$hCancel = GUICtrlCreateButton("Cancel", 160 + 74, 150, 70, 24)

	GUISetState()
	While 1
		Switch GUIGetMsg()
			Case $hPlace
				$sString = FileSelectFolder("Change directory for backup folders:" & @LF & $sBackupDir, "", 3, $Global_LupoDir)
				If $sString <> "" Then
					$sBackupDir = $sString
					If StringInStr($sBackupDir, $Global_LupoDir) Then $sBackupDir = "..\.." & StringTrimLeft($sBackupDir, StringLen($Global_LupoDir))
					If $sBackupDir = "..\.." Then $sBackupDir = "..\..\Backups"
					IniWrite($Global_INI, "General", "BackupDir", $sBackupDir)
				EndIf

			Case $hBackup
				If StringInStr($sBackupDir, $Global_LupoDir) Then $sBackupDir = "..\.." & StringTrimLeft($sBackupDir, StringLen($Global_LupoDir))
				If $sBackupDir = "..\.." Then $sBackupDir = "..\..\Backups"
				IniWrite($Global_INI, "General", "BackupDir", $sBackupDir)
				IniWrite($Global_INI, "General", "RestoreDir", $sBackupDir & "\" & $Global_BackupFolder)
				If GUICtrlRead($aImport[0]) = 1 Then $iReturnValue = 1
				If GUICtrlRead($aImport[1]) = 1 Then $iReturnValue = $iReturnValue + 2
				If GUICtrlRead($aImport[2]) = 1 Then $iReturnValue = $iReturnValue + 4
				If GUICtrlRead($aImport[3]) = 1 Then $iReturnValue = $iReturnValue + 8
				ExitLoop

			Case $hCancel, $GUI_EVENT_CLOSE
				$iReturnValue = 0
				ExitLoop

		EndSwitch
	WEnd

	GUIDelete($hGUI)
	Return $iReturnValue
EndFunc   ;==>_Apps_Backup_Config

Func _Apps_Backup($hParentGUI, $hClose, $hProgressBar)
	Local $hMsg, $hFileOpen, $hDownload, $hProcess, $sBackupFolder, $sAppINI, $sAppsDir, $sAppFolder, $sAppName, $sAppType
	Local $sMainBackupDir, $sBackupDir, $sSourceDir, $sTargetDir, $iNumberItems, $iDecision, $iSubDecision, $K
	Local $aList1, $aList2, $aList3, $aList4, $fState = "true", $iCount = 0, $iChecked = 0, $fAborted = 0

	$iNumberItems = _GUICtrlListView_GetItemCount($Global_ListView)
	For $K = 0 To $iNumberItems - 1
		If _GUICtrlListView_GetItemChecked($Global_ListView, $K) Then $iChecked = $iChecked + 1
	Next

	$iDecision = _Apps_Backup_Config($hParentGUI, $iChecked)
	If $iDecision = 0 Then
		Return 2
	Else
		If FileExists(StringTrimRight($Global_7zip, 8)) = 0 Then
			DirCreate(StringTrimRight($Global_7zip, 8))
		EndIf
		If FileExists($Global_7zip) = 0 Then
			$hDownload = InetGet($Global_Site & "files/7za.exe", $Global_7zip, 1)
			If InetGetInfo($hDownload, 4) <> 0 Then FileDelete($Global_7zip)
		EndIf
		If FileExists($Global_7zip) = 0 Then
			MsgBox(0, "Compressor not found", 'Unable to make backup, compressor not found. Download "7za.exe" from www.7-zip.org and place it here:' & @LF & StringTrimRight($Global_7zip, 8))
			Return 0
		EndIf
		$sMainBackupDir = IniRead($Global_INI, "General", "BackupDir", "")
		If $sMainBackupDir = "" Then $sMainBackupDir = "..\..\MyFiles\Backups"
		$sBackupDir = $sMainBackupDir & '\' & $Global_BackupFolder
		If FileExists($sBackupDir) = 0 Then DirCreate($sBackupDir)
		; start log file
		If FileExists($sBackupDir & "\Backup.log") Then
			$iSubDecision = MsgBox(0x00004, "Alert message", "Daily backup already made. Do you want to update it with this new one?" & @LF & "(in case of duplicate backups, it will be kept also the previous copy)")
			If $iSubDecision <> 6 Then Return 2
			$sBackupFolder = "Update"
		Else
			$sBackupFolder = StringRight($Global_BackupFolder, 10)
		EndIf
		$hFileOpen = FileOpen($sBackupDir & "\Backup.log", 1)
		FileWriteLine($hFileOpen, "=============================================")
		FileWriteLine($hFileOpen, "  Lupo PenSuite Backup Log {" & $sBackupFolder & "}")
		FileWrite($hFileOpen, "  Mode: ")
		If $iDecision = 5 Or $iDecision = 9 Then
			FileWrite($hFileOpen, "Selected apps - ")
		Else
			FileWrite($hFileOpen, "All listed apps - ")
		EndIf
		If $iDecision < 7 Then
			FileWrite($hFileOpen, "Settings only" & @CRLF)
		Else
			FileWrite($hFileOpen, "Complete apps" & @CRLF)
		EndIf
		FileWriteLine($hFileOpen, "=============================================")
		FileWriteLine($hFileOpen, "")
		FileClose($hFileOpen)
		For $K = 0 To $iNumberItems - 1
			$hMsg = GUIGetMsg()
			If $hMsg = $hClose Then
				$fAborted = 1
				ExitLoop
			EndIf
			If $iDecision = 5 Or $iDecision = 9 Then
				$fState = _GUICtrlListView_GetItemChecked($Global_ListView, $K) ; Backup only selected apps
			Else
				$iChecked = $iNumberItems
			EndIf
			If $fState = "true" Then
				$iCount = $iCount + 1
				GUICtrlSetData($hProgressBar, (100 / $iChecked) * $iCount)
				$sAppName = _GUICtrlListView_GetItemText($Global_ListView, $K, 0)
				$sAppFolder = _GUICtrlListView_GetItemText($Global_ListViewHidden, $K, 0)
				$sAppType = _GUICtrlListView_GetItemText($Global_ListView, $K, 4)
				$sAppsDir = _Get_AppsDir($sAppType)
				$sSourceDir = $sAppsDir & '\' & $sAppFolder
				$sTargetDir = $sBackupDir & '\' & $sAppFolder
				; check if the application is in use
				$sAppINI = $sSourceDir & "\LupoApp.ini"
				$hProcess = IniRead($sAppINI, "Software", "Main", $sAppName & ".exe")
				If ProcessExists($hProcess) Then MsgBox(0x40000, "Software in use", $sAppName & " is running. Close it now to correctly backup its settings." & @LF & "(otherwise its backup will be skipped)")
				If ProcessExists($hProcess) Then
					$aList1 &= "|" & $sAppName
				Else
					If $iDecision < 7 Then
						; Backup Settings
						If FileExists($sTargetDir) = 0 Then DirCreate($sTargetDir)
						If FileExists($sAppINI) Then
							FileCopy($sAppINI, $sTargetDir)
							_Apps_ImportSettings($sAppsDir, $sAppFolder, $sBackupDir, $sAppFolder, 1)
							FileDelete($sTargetDir & "\LupoApp.ini")
						Else
							If FileExists($sSourceDir & "\App\AppInfo\appinfo.ini") Then
								DirCopy($sSourceDir & '\Data', $sTargetDir & '\Data')
							Else
								$aList2 &= "|" & $sAppName
								DirRemove($sTargetDir, 1)
							EndIf
						EndIf
						If FileExists($sTargetDir) Then
							If DirGetSize($sTargetDir) = 0 Then
								$aList3 &= "|" & $sAppName
							Else
								If FileExists($sTargetDir & '.zip') Then
									If FileExists($sTargetDir & '_old.zip') Then FileDelete($sTargetDir & '_old.zip')
									FileMove($sTargetDir & '.zip', $sTargetDir & '_old.zip')
									FileDelete($sTargetDir & '.zip')
								EndIf
								RunWait('"' & $Global_7zip & '" a -tzip -mm=Deflate -mx7 -md=32k -mfb=64 -mpass=3 "' & $sTargetDir & '.zip" "' & $sTargetDir & '"', "", @SW_HIDE)
								$aList4 &= "|" & $sAppName
							EndIf
							DirRemove($sTargetDir, 1)
						EndIf
					Else
						; Backup Complete Apps
						If FileExists($sTargetDir & '.zip') Then
							If FileExists($sTargetDir & '_old.zip') Then FileDelete($sTargetDir & '_old.zip')
							FileMove($sTargetDir & '.zip', $sTargetDir & '_old.zip')
							FileDelete($sTargetDir & '.zip')
						EndIf
						RunWait('"' & $Global_7zip & '" a -tzip -mm=Deflate -mx7 -md=32k -mfb=64 -mpass=3 "' & $sTargetDir & '.zip" "' & $sSourceDir & '"', "", @SW_HIDE)
						$aList4 &= "|" & $sAppName
					EndIf
				EndIf
			EndIf
		Next

		$hFileOpen = FileOpen($sBackupDir & "\Backup.log", 1)
		If $iDecision = 10 Then
			FileWriteLine($hFileOpen, "All processed apps successfully backupped.")
		Else
			If $aList1 = "" Then $aList1 = "|None"
			If $aList2 = "" Then $aList2 = "|None"
			If $aList3 = "" Then $aList3 = "|None"
			$aList1 = StringSplit($aList1, "|")
			$aList2 = StringSplit($aList2, "|")
			$aList3 = StringSplit($aList3, "|")
			$aList4 = StringSplit($aList4, "|")
			FileWriteLine($hFileOpen, "Apps skipped because in use during backup:")
			For $K = 2 To $aList1[0]
				FileWriteLine($hFileOpen, "> " & $aList1[$K])
			Next
			FileWriteLine($hFileOpen, "")
			If $iDecision < 7 Then
				FileWriteLine($hFileOpen, "Apps skipped because don't support settings backup:")
				For $K = 2 To $aList2[0]
					FileWriteLine($hFileOpen, "> " & $aList2[$K])
				Next
				FileWriteLine($hFileOpen, "")
				FileWriteLine($hFileOpen, "Apps skipped because don't have settings saved:")
				For $K = 2 To $aList3[0]
					FileWriteLine($hFileOpen, "> " & $aList3[$K])
				Next
				FileWriteLine($hFileOpen, "")
			EndIf
			FileWriteLine($hFileOpen, "Apps successfully backupped:")
			For $K = 2 To $aList4[0]
				FileWriteLine($hFileOpen, "> " & $aList4[$K])
			Next
		EndIf
		If $fAborted = 1 Then
			FileWriteLine($hFileOpen, "")
			FileWriteLine($hFileOpen, "! Backup procedure interrupted by the user !")
		EndIf
		FileWriteLine($hFileOpen, "")
		FileWriteLine($hFileOpen, "")
		FileClose($hFileOpen)
	EndIf

	If $fAborted = 1 Then Return -1
	Return 0
EndFunc   ;==>_Apps_Backup

Func _Apps_Restore_Config($hParentGUI, $iChecked)
	Local $hGUI, $hRestore, $hBackupField, $hSearch, $hCancel, $iReturnValue, $sString, $aImport[2]

	$hGUI = GUICreate("Restore Backup", 320, 172, -1, -1, -1, $WS_EX_TOOLWINDOW, $hParentGUI)

	GUICtrlCreateLabel("Important: close all portable software that will be restored.", 13, 10, 300)
	GUICtrlSetFont(-1, -1, 400, 4)
	GUICtrlCreateGroup("What backups do you want to restore?", 9, 36, 302, 47)
	$aImport[0] = GUICtrlCreateRadio("Only selected apps", 24, 53, 130, 20)
	$aImport[1] = GUICtrlCreateRadio("All available apps", 165, 53, 130, 20)
	GUICtrlSetState($aImport[0], 1)
	If $iChecked = 0 Then
		GUICtrlSetState($aImport[1], 1)
		GUICtrlSetState($aImport[0], $GUI_DISABLE)
	EndIf
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateLabel('Backup folder to restore:   (eg. "' & $Global_BackupFolder & '")', 18, 92)
	$hBackupField = GUICtrlCreateInput(IniRead($Global_INI, "General", "RestoreDir", ""), 10, 108, 300, 20)
	$hSearch = GUICtrlCreateButton("Search", 160 - 70 - 74, 139, 70, 24)
	GUICtrlSetTip(-1, "Select the backup folder you want to restore")
	$hRestore = GUICtrlCreateButton("Restore", 160 - 40, 138, 80, 26)
	GUICtrlSetTip(-1, "Start to restore apps from the selected backup folder")
	$hCancel = GUICtrlCreateButton("Cancel", 160 + 74, 139, 70, 24)

	GUISetState()
	While 1
		Switch GUIGetMsg()
			Case $hSearch
				$sString = FileSelectFolder("Change backup folder to restore:" & @LF & GUICtrlRead($hBackupField), "", 2, $Global_LupoDir)
				If $sString <> "" Then
					If StringRight(StringTrimRight($sString, 11), 10) = "LupoBackup" Then
						If StringInStr($sString, $Global_LupoDir) Then $sString = "..\.." & StringTrimLeft($sString, StringLen($Global_LupoDir))
						GUICtrlSetData($hBackupField, $sString)
					Else
						MsgBox(0, "Wrong folder selected", $Global_Error5)
					EndIf
				EndIf

			Case $hRestore
				$sString = GUICtrlRead($hBackupField)
				If StringRight(StringTrimRight($sString, 11), 10) = "LupoBackup" And FileExists($sString) Then
					IniWrite($Global_INI, "General", "RestoreDir", $sString)
					If GUICtrlRead($aImport[0]) = 1 Then $iReturnValue = 1
					If GUICtrlRead($aImport[1]) = 1 Then $iReturnValue = 2
					ExitLoop
				Else
					MsgBox(0, "Wrong folder selected", $Global_Error5)
				EndIf

			Case $hCancel, $GUI_EVENT_CLOSE
				$iReturnValue = 0
				ExitLoop

		EndSwitch
	WEnd

	GUIDelete($hGUI)
	Return $iReturnValue
EndFunc   ;==>_Apps_Restore_Config

Func _Apps_Restore($hParentGUI, $hClose, $hProgressBar)		; (add log?)
	Local $hMsg, $hProcess, $hDownload, $sAppsDir, $sRestoreDir, $sAppINI, $sAppFolder, $sAppName, $sAppType, $sSourceDir, $sTargetDir
	Local $iDecision, $iNumberItems, $K, $fState = "true", $iCount = 0, $iChecked = 0, $fAborted = 0

	$iNumberItems = _GUICtrlListView_GetItemCount($Global_ListView)
	For $K = 0 To $iNumberItems - 1
		If _GUICtrlListView_GetItemChecked($Global_ListView, $K) Then $iChecked = $iChecked + 1
	Next

	$iDecision = _Apps_Restore_Config($hParentGUI, $iChecked)
	If $iDecision = 0 Then
		Return 2
	Else
		If FileExists(StringTrimRight($Global_7zip, 8)) = 0 Then
			DirCreate(StringTrimRight($Global_7zip, 8))
		EndIf
		If FileExists($Global_7zip) = 0 Then
			$hDownload = InetGet($Global_Site & "files/7za.exe", $Global_7zip, 1)
			If InetGetInfo($hDownload, 4) <> 0 Then FileDelete($Global_7zip)
		EndIf
		If FileExists($Global_7zip) = 0 Then
			MsgBox(0, "Extractor not found", 'Unable to restore backups, extractor not found. Download "7za.exe" from www.7-zip.org and place it here:' & @LF & StringTrimRight($Global_7zip, 8))
			Return 0
		EndIf
		$sRestoreDir = IniRead($Global_INI, "General", "RestoreDir", "")
		For $K = 0 To $iNumberItems - 1
			$hMsg = GUIGetMsg()
			If $hMsg = $hClose Then
				$fAborted = 1
				ExitLoop
			EndIf
			If $iDecision = 1 Then
				$fState = _GUICtrlListView_GetItemChecked($Global_ListView, $K) ; Restore only selected apps
			Else
				$iChecked = $iNumberItems
			EndIf
			If $fState = "true" Then
				$iCount = $iCount + 1
				GUICtrlSetData($hProgressBar, (100 / $iChecked) * $iCount)
				$sAppName = _GUICtrlListView_GetItemText($Global_ListView, $K, 0)
				$sAppFolder = _GUICtrlListView_GetItemText($Global_ListViewHidden, $K, 0)
				$sAppType = _GUICtrlListView_GetItemText($Global_ListView, $K, 4)
				$sAppsDir = _Get_AppsDir($sAppType)
				$sSourceDir = $sRestoreDir & '\' & $sAppFolder
				$sTargetDir = $sAppsDir & '\' & $sAppFolder
				; check if the application is in use
				$sAppINI = $sTargetDir & "\LupoApp.ini"
				$hProcess = IniRead($sAppINI, "Software", "Main", $sAppName & ".exe")
				If ProcessExists($hProcess) Then MsgBox(0x40000, "Software in use", $sAppName & " is running. Close it now to correctly restore its settings." & @LF & "(otherwise its restore will be skipped)")
				If ProcessExists($hProcess) = 0 Then
					If FileExists($sSourceDir & '.zip') Then
						If FileExists($sSourceDir) Then DirRemove($sSourceDir, 1)
						RunWait('"' & $Global_7zip & '" x -aoa "-o' & $sRestoreDir & '\" "' & $sSourceDir & '.zip"', "", @SW_HIDE)
						If FileExists($sAppINI) Then
							If FileExists($sSourceDir & "\LupoApp.ini") Then
								; Complete Apps
								DirRemove($sTargetDir, 1)
								If FileExists($sTargetDir) Then
									; <---------------- add in log
								Else
									DirMove($sSourceDir, $sTargetDir, 1)
								EndIf
							Else
								; Settings Only
								_Apps_ImportSettings($sRestoreDir, $sAppFolder, $sAppsDir, $sAppFolder, 2)
								DirRemove($sSourceDir, 1)
							EndIf
						Else
							If FileExists($sTargetDir & "\App\AppInfo\appinfo.ini") Then
								If FileExists($sSourceDir & "\App\AppInfo\appinfo.ini") Then
									; Complete Apps
									DirRemove($sTargetDir, 1)
									If FileExists($sTargetDir) Then
										; <---------------- add in log
									Else
										DirMove($sSourceDir, $sTargetDir, 1)
									EndIf
								Else
									; Settings Only
									DirRemove($sTargetDir & '\Data', 1)
									If FileExists($sTargetDir & '\Data') Then
										; <---------------- add in log
									Else
										DirCopy($sSourceDir & '\Data', $sTargetDir & '\Data')
										DirRemove($sSourceDir, 1)
									EndIf
								EndIf
							Else
								DirMove($sSourceDir, $sTargetDir, 1)
							EndIf
						EndIf
					Else
						; <---------------- add in log
					EndIf
				EndIf
			EndIf
		Next
	EndIf

	If $fAborted = 1 Then Return -1
	Return 0
EndFunc   ;==>_Apps_Restore

Func _Apps_Remove($iItem)
	Local $sXML, $aArray, $sAppsDir, $sAppType, $iDecision, $sFileName, $sLine, $hInputOpen, $hOutputOpen

	$sXML = $Global_LupoDir & "\Launcher\ASuite.xml"
	$iDecision = MsgBox(0x00004, "Removal confirmation", "Are you sure to completely remove this application from device?" & @LF & "(close the Suite launcher to remove it also from menu)")
	If $iDecision = 6 Then
		$sFileName = _GUICtrlListView_GetItemText($Global_ListViewHidden, $iItem, 0)
		$sAppType = _GUICtrlListView_GetItemText($Global_ListView, $iItem, 4)
		$sAppsDir = _Get_AppsDir($sAppType) & '\' & $sFileName
		DirRemove($sAppsDir, 1)

		$hInputOpen = FileOpen($sXML, 0)
		$hOutputOpen = FileOpen($Global_TempFile, 2)
		While 1
			$sLine = FileReadLine($hInputOpen)
			If @error = -1 Then ExitLoop
			If StringInStr($sLine, 'name="' & $sFileName) Then
				While StringInStr($sLine, "</Software>") = 0
					$sLine = FileReadLine($hInputOpen)
					If StringInStr($sLine, "<PathCache>") Then
						$aArray = StringRegExp($sLine, '>(.*?)<', 3)
						If StringInStr($aArray[0], "cache") Then
							FileDelete($Global_LupoDir & "\Launcher\" & $aArray[0])
						EndIf
					EndIf
				WEnd
				$sLine = FileReadLine($hInputOpen)
			EndIf
			FileWriteLine($hOutputOpen, $sLine)
		WEnd
		FileClose($hInputOpen)
		FileClose($hOutputOpen)
		FileCopy($Global_TempFile, $sXML, 1)
		FileDelete($Global_TempFile)

		If FileExists($sAppsDir) Then
			MsgBox(0, "Removal failed", "Software in use, the removal is failed. Close it and try again.")
		Else
			_GUICtrlListView_DeleteItem($Global_ListView, $iItem)
			_GUICtrlListView_DeleteItem($Global_ListViewHidden, $iItem)
		EndIf
	EndIf
EndFunc   ;==>_Apps_Remove

Func _Apps_Options($hParentGUI, $sLupoTempDir)
	Local $hGUI, $hOK, $hCancel, $hInfo, $hOpen, $hRemove, $hSelect, $aCheckbox[2], $aMode[2], $sState

	$hGUI = GUICreate("Options", 310, 194, -1, -1, -1, $WS_EX_TOOLWINDOW, $hParentGUI)

	GUICtrlCreateGroup("General Options", 8, 6, 294, 76)
	$aCheckbox[0] = GUICtrlCreateCheckbox("Auto-check for single updates at the Suite startup", 18, 24, 280, 20)
	$aCheckbox[1] = GUICtrlCreateCheckbox("Scan also an additional folder", 18, 50, 166, 20)
	$hSelect = GUICtrlCreateButton("Select", 190, 50, 70, 22)
	$hInfo = GUICtrlCreateIcon(@ScriptFullPath, -9, 270, 53, 16, 16)
	GUICtrlSetTip($hInfo, "You can select a custom folder if you want," & @LF & "to check also software contained in it.", "Custom folder", 1, 2)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("Update Mode", 8, 90, 106, 68)
	$aMode[0] = GUICtrlCreateRadio("Keep old", 19, 108, 80, 20)
	GUICtrlSetTip(-1, "Keep old versions of updated software in temporary folder")
	$aMode[1] = GUICtrlCreateRadio("On-the-fly", 19, 128, 80, 20)
	GUICtrlSetTip(-1, "Remove old versions of updated software after the update")
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("Temporary Folder", 120, 90, 182, 68)
	$hOpen = GUICtrlCreateButton("Open", 134, 116, 70, 22)
	GUICtrlSetTip(-1, "Open updates temporary folder")
	$hRemove = GUICtrlCreateButton("Remove", 218, 116, 70, 22)
	GUICtrlSetTip(-1, "Remove updates temporary folder")
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	If IniRead($Global_INI, "General", "AutoCheckApps", "OFF") = "ON" Then
		GUICtrlSetState($aCheckbox[0], 1)
	Else
		GUICtrlSetState($aCheckbox[0], 4)
	EndIf
	If IniRead($Global_INI, "General", "UseCustomFolder", "NO") = "YES" Then
		GUICtrlSetState($aCheckbox[1], 1)
		GUICtrlSetState($hSelect, $GUI_ENABLE)
	Else
		GUICtrlSetState($aCheckbox[1], 4)
		GUICtrlSetState($hSelect, $GUI_DISABLE)
	EndIf
	If IniRead($Global_INI, "General", "UpdateMode", "Keep") = "Keep" Then
		GUICtrlSetState($aMode[0], 1)
		GUICtrlSetState($aMode[1], 4)
	Else
		GUICtrlSetState($aMode[0], 4)
		GUICtrlSetState($aMode[1], 1)
	EndIf

	$hOK = GUICtrlCreateButton("OK", 155 - 80 - 30, 164, 80, 24)
	$hCancel = GUICtrlCreateButton("Cancel", 155 + 30, 164, 80, 24)
	GUICtrlSetState($hOK, $GUI_FOCUS)
	GUISetState()

	While 1
		Switch GUIGetMsg()
			Case $aCheckbox[1]
				If GUICtrlRead($aCheckbox[1]) = 1 Then
					GUICtrlSetState($hSelect, $GUI_ENABLE)
				Else
					GUICtrlSetState($hSelect, $GUI_DISABLE)
				EndIf

			Case $hSelect
				If $Global_CustomDir = "None" Then
					$sState = FileSelectFolder("Select custom folder:", "", 2)
				Else
					$sState = FileSelectFolder("Actual custom folder:" & @LF & $Global_CustomDir, "", 2)
				EndIf
				If $sState <> "" Then
					IniWrite($Global_INI, "General", "CustomFolder", $sState)
					MsgBox(0, "Restart the tool", "You need to restart Manage Apps to load apps also from this folder.")
				EndIf

			Case $hOpen
				If FileExists($sLupoTempDir) = 0 Then DirCreate($sLupoTempDir)
				ShellExecute($sLupoTempDir)

			Case $hRemove
				DirRemove($sLupoTempDir, 1)

			Case $hOK
				$sState = "OFF"
				If GUICtrlRead($aCheckbox[0]) = 1 Then $sState = "ON"
				IniWrite($Global_INI, "General", "AutoCheckApps", $sState)

				$sState = "NO"
				If GUICtrlRead($aCheckbox[1]) = 1 Then $sState = "YES"
				IniWrite($Global_INI, "General", "UseCustomFolder", $sState)

				$sState = "On-the-fly"
				If GUICtrlRead($aMode[0]) = 1 Then $sState = "Keep"
				IniWrite($Global_INI, "General", "UpdateMode", $sState)

				$Global_CustomDir = IniRead($Global_INI, "General", "CustomFolder", "None")
				$Global_UseCustom = IniRead($Global_INI, "General", "UseCustomFolder", "NO")
				ExitLoop

			Case $hCancel, $GUI_EVENT_CLOSE
				ExitLoop

		EndSwitch
	WEnd

	GUIDelete($hGUI)
EndFunc   ;==>_Apps_Options

Func _Apps($hMainGUI, $fBackgroundMode, $sBrowser)
	Local $hGUI, $hMsg, $hCheckboxAll, $hCheck, $hBackup, $hOptions, $hClose, $hStatusText, $hDownload, $hProgressBar, $hInfo, $hImage, $hMenu, $hSubMenu
	Local $hListView, $hListViewHidden, $iRunPage, $iChecking, $iManual, $iNumberItems, $iItem, $iSize, $iDecision = 0, $fChecked = 0, $aMenuItem[10]
	Local $aStringSplit, $sString, $sSkipItem, $sSkipList, $sSkipName, $sPageLink, $sPluralChecking = "", $sPluralManual = "", $sLupoTempDir = @TempDir & "\LupoTemp"

	$hGUI = GUICreate("Manage Apps", 520, 380, -1, -1, -1, -1, $hMainGUI)
	GUISetIcon(@ScriptFullPath, -8)
	GUISetBkColor(0x0A0A52)

	GUICtrlCreateLabel("Update, backup, restore and remove software of your collection.", 90, 8, 380, 18)
	GUICtrlSetColor(-1, 0xE5E5E5)
	$hCheckboxAll = GUICtrlCreateCheckbox("", 14, 37, 13, 13)
	GUICtrlSetState($hCheckboxAll, $GUI_ONTOP)
	_Set_Proxy()

	$Global_Dummy = GUICtrlCreateDummy()
	$hMenu = GUICtrlCreateContextMenu($Global_Dummy)
	$aMenuItem[0] = GUICtrlCreateMenuItem("Description", $hMenu)
	$aMenuItem[1] = GUICtrlCreateMenuItem("Web Page", $hMenu)
	GUICtrlCreateMenuItem("", $hMenu)
	$aMenuItem[2] = GUICtrlCreateMenuItem("Import Settings", $hMenu)
	$aMenuItem[3] = GUICtrlCreateMenuItem("Force Update", $hMenu)
	$aMenuItem[4] = GUICtrlCreateMenuItem("Don't Check", $hMenu)
	$aMenuItem[5] = GUICtrlCreateMenuItem("Download", $hMenu)
	GUICtrlCreateMenuItem("", $hMenu)
	$aMenuItem[6] = GUICtrlCreateMenuItem("Remove", $hMenu)

	$hSubMenu = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	$aMenuItem[7] = GUICtrlCreateMenuItem("Create Backup", $hSubMenu)
	$aMenuItem[8] = GUICtrlCreateMenuItem("Restore Backup", $hSubMenu)
	GUICtrlCreateMenuItem("", $hSubMenu)
	$aMenuItem[9] = GUICtrlCreateMenuItem("Backup Folder", $hSubMenu)

	$hListView = GUICtrlCreateListView("     Software|Version|Update|Size|Type", 8, 30, 504, 294, BitOr($LVS_NOSORTHEADER, $LVS_REPORT, $LVS_SINGLESEL))
    $Global_ListView = GUICtrlGetHandle($hListView)
	$hListViewHidden = GUICtrlCreateListView("Folder|Description|Location|Skip|Download", 600, 30, 200, 294)
	$Global_ListViewHidden = GUICtrlGetHandle($hListViewHidden)
    _GUICtrlListView_SetExtendedListViewStyle($Global_ListView, BitOr($LVS_EX_CHECKBOXES, $LVS_EX_DOUBLEBUFFER, $LVS_EX_FULLROWSELECT, $LVS_EX_GRIDLINES, $LVS_EX_INFOTIP))
	_GUICtrlListView_SetColumnWidth($Global_ListView, 0, 175)
	_GUICtrlListView_SetColumnWidth($Global_ListView, 1, 84)
	_GUICtrlListView_SetColumnWidth($Global_ListView, 2, 84)
	_GUICtrlListView_SetColumnWidth($Global_ListView, 3, 80)
	_GUICtrlListView_SetColumnWidth($Global_ListView, 4, 58)
	$hProgressBar = GUICtrlCreateProgress(8, 328, 504, 8)

	If $fBackgroundMode = 0 Then
		; Normal process
		$hInfo = GUICtrlCreateButton("?", 493, 5, 20, 20)
		GUICtrlSetTip(-1, "More info about this tool")
		$hCheck = GUICtrlCreateButton("Check", 30, 344, 80, 26)
		GUICtrlSetTip(-1, "Check online for software updates")
		$hBackup = GUICtrlCreateButton("Backup", 130, 344, 80, 26)
		$hOptions = GUICtrlCreateButton("Options", 310, 344, 80, 26)
		$hClose = GUICtrlCreateButton("Close", 410, 344, 80, 26)
		GUICtrlSetState($hCheck, $GUI_FOCUS)

		GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
		GUISetState()

		$hImage = _GUIImageList_Create(16, 16, 5, 1)
		GUICtrlSetState($hListView, $GUI_DISABLE)
		GUICtrlSetState($hCheck, $GUI_DISABLE)
		GUICtrlSetState($hBackup, $GUI_DISABLE)
		GUICtrlSetState($hOptions, $GUI_DISABLE)
		$hStatusText = GUICtrlCreateLabel("Loading...", 234, 350, 71, 18)
		GUICtrlSetColor($hStatusText, 0xE5E5E5)
		_Apps_Find($hImage, $Global_LupoDir & "\Apps", "Apps")
		_Apps_Find($hImage, $Global_LupoDir & "\Apps\Extra", "Extra")
		_Apps_Find($hImage, $Global_LupoDir & "\Apps\Games", "Games")
		_Apps_Find($hImage, $Global_LupoDir & "\MyApps", "MyApps")
		If $Global_UseCustom = "YES" And $Global_CustomDir <> "None" Then _Apps_Find($hImage, $Global_CustomDir, "Custom")
		_GUICtrlListView_SetImageList($Global_ListView, $hImage, 1)
		GUICtrlDelete($hStatusText)
		GUICtrlSetState($hListView, $GUI_ENABLE)
		GUICtrlSetState($hCheck, $GUI_ENABLE)
		GUICtrlSetState($hBackup, $GUI_ENABLE)
		GUICtrlSetState($hOptions, $GUI_ENABLE)

		While 1
			$hMsg = GUIGetMsg()
			Switch $hMsg
				Case $hClose, $GUI_EVENT_CLOSE
					ExitLoop

				Case $hInfo
					MsgBox(0, "Tips and Tricks", '- From Options you can active the check for single updates at the Suite startup, that allow you to keep your collection daily updated.' & @LF & @LF & '- Apps settings are imported during the update, but in case of problems the old application is available in temporary folder (you can access it from Options).' & @LF & @LF & '- If you have not a broadband connection, you can interrupt the update procedure (click Close during the updating) and complete it later.' & @LF & @LF & '- Some software updates are in English only, for them you can download the translation from their web page (link to visit it is available from right-click menu).' & @LF & @LF & '- From Options you can select an additional folder that contains portable software, to check for updates also software contained in it.' & @LF & @LF & '- You can easily Backup and Restore your portable software (are supported both Settings Only and Complete Apps backup modes).' & @LF & @LF & '- The Download button is actived after the checking, only for apps that support it (to download them separately on Desktop).' & @LF & @LF & '- The Force Update feature allow to update apps even if there are not new updates available, to restore software that present problems.')

				Case $hCheck
					GUICtrlSetState($hCheck, $GUI_DISABLE)
					GUICtrlSetState($hBackup, $GUI_DISABLE)
					GUICtrlSetState($hOptions, $GUI_DISABLE)
					GUICtrlSetState($hListView, $GUI_DISABLE)
					If $fChecked = 0 Then
						If BinaryToString(InetRead($Global_Site & "downloads/ok.txt", 17)) <> "YES" Then
							MsgBox(0, "Check failed", $Global_Error2)
						Else
							$fChecked = 1
							$iManual = 0
							$hStatusText = GUICtrlCreateLabel("Checking...", 233, 350, 72, 18)
							GUICtrlSetColor($hStatusText, 0xE5E5E5)
							GUICtrlSetState($hCheckboxAll, $GUI_UNCHECKED)
							$iChecking = _Apps_Check($hClose, $hProgressBar, -1)
							GUICtrlDelete($hStatusText)
							If $iChecking < 0 Then
								GUIDelete($hGUI)
								Return SetError(1, 0, 0)
							EndIf
							$iNumberItems = _GUICtrlListView_GetItemCount($Global_ListView)
							GUICtrlSetData($hCheck, "Update")
							GUICtrlSetTip($hCheck, "Update selected applications")
							For $K = 0 To $iNumberItems - 1
								If _GUICtrlListView_GetItemChecked($Global_ListView, $K) Then $iChecking = $iChecking + 1
								If StringInStr(_GUICtrlListView_GetItemText($Global_ListView, $K, 2), "*manual") Then $iManual = $iManual + 1
							Next
							If $iChecking <> 1 Then $sPluralChecking = "s"
							If $iManual <> 1 Then $sPluralManual = "s"
							If $iChecking = 0 And $iManual = 0 Then
								$sString = "No updates available for your software."
							ElseIf $iManual = 0 Then
								$sString = $iChecking & " internal update" & $sPluralChecking & " available (automatically selected)."
							Else
								$sString = "Results of the check for updates:" & @LF & "> " & $iChecking & " internal update" & $sPluralChecking & " available (automatically selected)" & @LF & "> " & $iManual & " external update" & $sPluralManual & " available (only manual update)"
							EndIf
							MsgBox(0, "Check results", $sString)
						EndIf
						If $iChecking > 0 Then GUICtrlSetState($hCheck, $GUI_ENABLE)
					Else
						If BinaryToString(InetRead($Global_Site & "downloads/ok.txt", 17)) <> "YES" Then
							MsgBox(0, "Update failed", $Global_Error2)
						Else
							$hStatusText = GUICtrlCreateLabel("Updating...", 233, 350, 72, 18)
							GUICtrlSetColor($hStatusText, 0xE5E5E5)
							$iChecking = _Apps_Update($sLupoTempDir, $iDecision, $hClose, $hProgressBar, -1)
							GUICtrlDelete($hStatusText)
							If $iChecking <> -2 Then
								If $iChecking < 0 Then
									MsgBox(0, "Update interrupted", "Update" & $Global_Error3)
									GUIDelete($hGUI)
									Return SetError(1, 0, 0)
								EndIf
								For $K = 0 To $iNumberItems - 1
									If _GUICtrlListView_GetItemText($Global_ListView, $K, 2) = "Failed" Then
										MsgBox(0, "Some updates failed", $Global_Error4)
										ExitLoop
									EndIf
									If $K = $iNumberItems - 1 Then MsgBox(0x40000, "Update completed", $Global_SuiteName & " apps successfully updated.")
								Next
							EndIf
						EndIf
						GUICtrlSetState($hCheck, $GUI_ENABLE)
					EndIf
					GUICtrlSetState($hBackup, $GUI_ENABLE)
					GUICtrlSetState($hOptions, $GUI_ENABLE)
					GUICtrlSetState($hListView, $GUI_ENABLE)
					GUICtrlSetData($hProgressBar, 0)

				Case $hBackup
					ShowMenu($hGUI, $hMsg, $hSubMenu)

				Case $aMenuItem[7]
					GUICtrlSetState($hCheck, $GUI_DISABLE)
					GUICtrlSetState($hBackup, $GUI_DISABLE)
					GUICtrlSetState($hOptions, $GUI_DISABLE)
					GUICtrlSetState($hListView, $GUI_DISABLE)
					$hStatusText = GUICtrlCreateLabel("Backupping...", 227, 350, 78, 18)
					GUICtrlSetColor($hStatusText, 0xE5E5E5)
					$iChecking = _Apps_Backup($hGUI, $hClose, $hProgressBar)
					GUICtrlDelete($hStatusText)
					If $iChecking < 0 Then
						MsgBox(0, "Backup interrupted", "Backup" & $Global_Error3)
						GUIDelete($hGUI)
						Return SetError(1, 0, 0)
					ElseIf $iChecking <> 2 Then
						MsgBox(0x40000, "Backup completed", $Global_SuiteName & " apps successfully backupped." & @LF & "(log file is available in backup folder)")
					EndIf
					GUICtrlSetState($hCheck, $GUI_ENABLE)
					GUICtrlSetState($hBackup, $GUI_ENABLE)
					GUICtrlSetState($hOptions, $GUI_ENABLE)
					GUICtrlSetState($hListView, $GUI_ENABLE)
					GUICtrlSetData($hProgressBar, 0)

				Case $aMenuItem[8]
					GUICtrlSetState($hCheck, $GUI_DISABLE)
					GUICtrlSetState($hBackup, $GUI_DISABLE)
					GUICtrlSetState($hOptions, $GUI_DISABLE)
					GUICtrlSetState($hListView, $GUI_DISABLE)
					$hStatusText = GUICtrlCreateLabel("Restoring...", 231, 350, 74, 18)
					GUICtrlSetColor($hStatusText, 0xE5E5E5)
					$iChecking = _Apps_Restore($hGUI, $hClose, $hProgressBar)
					GUICtrlDelete($hStatusText)
					If $iChecking < 0 Then
						MsgBox(0, "Restore interrupted", "Restore" & $Global_Error3)
						GUIDelete($hGUI)
						Return SetError(1, 0, 0)
					ElseIf $iChecking <> 2 Then
						MsgBox(0x40000, "Restore completed", $Global_SuiteName & " apps successfully restored.")
					EndIf
					GUICtrlSetState($hCheck, $GUI_ENABLE)
					GUICtrlSetState($hBackup, $GUI_ENABLE)
					GUICtrlSetState($hOptions, $GUI_ENABLE)
					GUICtrlSetState($hListView, $GUI_ENABLE)
					GUICtrlSetData($hProgressBar, 0)

				Case $aMenuItem[9]
					$sString = IniRead($Global_INI, "General", "BackupDir", "")
					If $sString = "" Then $sString = "..\..\MyFiles\Backups"
					If FileExists($sString) = 0 Then DirCreate($sString)
					ShellExecute($sString)

				Case $hOptions
					_Apps_Options($hGUI, $sLupoTempDir)

				Case $hCheckboxAll
					If GUICtrlRead($hCheckboxAll) = 1 Then
						$iNumberItems = _GUICtrlListView_GetItemCount($Global_ListView)
						For $K = 0 To $iNumberItems - 1
							_GUICtrlListView_SetItemChecked($Global_ListView, $K)
						Next
					Else
						$iNumberItems = _GUICtrlListView_GetItemCount($Global_ListView)
						For $K = 0 To $iNumberItems - 1
							_GUICtrlListView_SetItemChecked($Global_ListView, $K, False)
						Next
					EndIf

				Case $Global_Dummy
					$iItem = GUICtrlRead($Global_Dummy)
					If $iItem >= 0 Then
						If _GUICtrlListView_GetItemText($Global_ListViewHidden, $iItem, 2) = "Unknown" Then
							GUICtrlSetState($aMenuItem[1], $GUI_DISABLE)
						Else
							GUICtrlSetState($aMenuItem[1], $GUI_ENABLE)
						EndIf
						If _GUICtrlListView_GetItemText($Global_ListViewHidden, $iItem, 4) = "" Then
							GUICtrlSetState($aMenuItem[5], $GUI_DISABLE)
						Else
							GUICtrlSetState($aMenuItem[5], $GUI_ENABLE)
						EndIf
						$sSkipList = IniRead($Global_INI, "SkipList", "ToSkip", "")
						If $sSkipList = "" Then
							$sSkipList = "|"
							IniWrite($Global_INI, "SkipList", "ToSkip", $sSkipList)
						EndIf
						$sSkipName = _GUICtrlListView_GetItemText($Global_ListView, $iItem, 0)
						If StringInStr($sSkipList, "|" & $sSkipName & "|") Then
							GUICtrlSetState($aMenuItem[4], 1)
						Else
							GUICtrlSetState($aMenuItem[4], 4)
						EndIf
						_GUICtrlMenu_TrackPopupMenu(GUICtrlGetHandle($hMenu), $hGUI)
					EndIf

				Case $aMenuItem[0]
					$sString = "Version:  "
					$iSize = _GUICtrlListView_GetItemText($Global_ListView, $iItem, 2)
					If StringInStr($iSize, ".") And $iSize <> "N.A." Then
						$sString = $sString & "from " & _GUICtrlListView_GetItemText($Global_ListView, $iItem, 1) & " to " & $iSize
					Else
						$sString = $sString & _GUICtrlListView_GetItemText($Global_ListView, $iItem, 1)
					EndIf
					$sString = $sString & @LF & @LF & "Description:  " & _GUICtrlListView_GetItemText($Global_ListViewHidden, $iItem, 1)
					$iSize = _GUICtrlListView_GetItemText($Global_ListView, $iItem, 3)
					If StringInStr($iSize, "MB") Then
						$aStringSplit = StringSplit($iSize, "/")
						$sString = $sString & @LF & @LF & "Download size:  " & $aStringSplit[1] & " MB" & @LF & "Disk space needed:  " & $aStringSplit[2]
					EndIf
					MsgBox(0x00040, _GUICtrlListView_GetItemText($Global_ListView, $iItem, 0), $sString)

				Case $aMenuItem[1]
					If _GUICtrlListView_GetItemText($Global_ListViewHidden, $iItem, 2) = "Internal" Then
						$sPageLink = $Global_Site & "db/" & StringLower(StringReplace(StringReplace(_GUICtrlListView_GetItemText($Global_ListView, $iItem, 0), "!", ""), " ", "")) & ".htm"
					Else
						$sPageLink = _GUICtrlListView_GetItemText($Global_ListViewHidden, $iItem, 2)
					EndIf
					$iRunPage = Run($sBrowser & " -new-tab " & $sPageLink, "", @SW_MAXIMIZE)
					If $iRunPage = 0 Then _IECreate($sPageLink, 1, 1, 0)

				Case $aMenuItem[2]
					$hStatusText = GUICtrlCreateLabel("Importing...", 232, 350, 73, 18)
					GUICtrlSetColor($hStatusText, 0xE5E5E5)
					$iChecking = _Apps_ImportSettings_Config($hGUI, $iItem)
					GUICtrlDelete($hStatusText)
					If $iChecking < 0 Then
						MsgBox(0, "Import failed", "The selected software does not support to import settings.")
					ElseIf $iChecking > 0 Then
						MsgBox(0, "Import completed", "Procedure completed and available settings imported.")
					EndIf

				Case $aMenuItem[3]
					GUICtrlSetState($hCheck, $GUI_DISABLE)
					GUICtrlSetState($hBackup, $GUI_DISABLE)
					GUICtrlSetState($hOptions, $GUI_DISABLE)
					GUICtrlSetState($hListView, $GUI_DISABLE)
					If BinaryToString(InetRead($Global_Site & "downloads/ok.txt", 17)) <> "YES" Then
						MsgBox(0, "Update failed", $Global_Error2)
					Else
						$hStatusText = GUICtrlCreateLabel("Checking...", 233, 350, 72, 18)
						GUICtrlSetColor($hStatusText, 0xE5E5E5)
						$iChecking = _Apps_Check($hClose, $hProgressBar, $iItem)
						GUICtrlDelete($hStatusText)
						If $iChecking < 0 Then
							GUIDelete($hGUI)
							Return SetError(1, 0, 0)
						EndIf
						If _GUICtrlListView_GetItemChecked($Global_ListView, $iItem) Then $iChecking = 1
						If $iChecking = 0 Then
							MsgBox(0, "Only manual update", "This software does not support automatic forced update.")
						Else
							$hStatusText = GUICtrlCreateLabel("Updating...", 233, 350, 72, 18)
							GUICtrlSetColor($hStatusText, 0xE5E5E5)
							$iChecking = _Apps_Update($sLupoTempDir, 6, $hClose, $hProgressBar, $iItem)
							GUICtrlDelete($hStatusText)
							If _GUICtrlListView_GetItemText($Global_ListView, $iItem, 2) = "Failed" Then
								MsgBox(0, "Update failed", "Verify if the software is opened, close it and try again.")
							Else
								MsgBox(0x40000, "Update completed", "Application successfully updated.")
							EndIf
						EndIf
					EndIf
					GUICtrlSetState($hCheck, $GUI_ENABLE)
					GUICtrlSetState($hBackup, $GUI_ENABLE)
					GUICtrlSetState($hOptions, $GUI_ENABLE)
					GUICtrlSetState($hListView, $GUI_ENABLE)
					GUICtrlSetData($hProgressBar, 0)

				Case $aMenuItem[4]
					If StringInStr($sSkipList, $sSkipName) Then
						$sSkipList = StringReplace($sSkipList, $sSkipName & "|", "")
						IniWrite($Global_INI, "SkipList", "ToSkip", $sSkipList)
						$sSkipItem = _GUICtrlListView_GetItemText($Global_ListViewHidden, $iItem, 3)
						If $sSkipItem = "" Then
							If $fChecked = 0 Then
								$sString = " - "
							Else
								$sString = "N.A."
							EndIf
						Else
							$sString = $sSkipItem
						EndIf
					Else
						IniWrite($Global_INI, "SkipList", "ToSkip", $sSkipList & $sSkipName & "|")
						$sSkipItem = _GUICtrlListView_GetItemText($Global_ListView, $iItem, 2)
						_GUICtrlListView_SetItemText($Global_ListViewHidden, $iItem, $sSkipItem, 3)
						$sString = "Skip it"
					EndIf
					_GUICtrlListView_SetItemText($Global_ListView, $iItem, $sString, 2)

				Case $aMenuItem[5]
					$hStatusText = GUICtrlCreateLabel("Downloading...", 225, 350, 80, 18)
					GUICtrlSetColor($hStatusText, 0xE5E5E5)
					$sPageLink = _GUICtrlListView_GetItemText($Global_ListViewHidden, $iItem, 4)
					$aStringSplit = StringSplit($sPageLink, '/', 1)
					$aStringSplit = $aStringSplit[$aStringSplit[0]]
					$hDownload = InetGet($sPageLink, @DesktopDir & "\" & $aStringSplit, 1)
					If InetGetInfo($hDownload, 4) <> 0 Then $aStringSplit = "0"
					GUICtrlDelete($hStatusText)
					If $aStringSplit = "0" Then MsgBox(0, "Download failed", "Download process failed. Visit the software page to manually download it.")

				Case $aMenuItem[6]
					$hStatusText = GUICtrlCreateLabel("Removing...", 231, 350, 74, 18)
					GUICtrlSetColor($hStatusText, 0xE5E5E5)
					_Apps_Remove($iItem)
					GUICtrlDelete($hStatusText)

			EndSwitch
		WEnd
	Else
		; Background process
		GUISetState(@SW_HIDE)
		_Apps_Find(-1, $Global_LupoDir & "\Apps", "Apps")
		_Apps_Find(-1, $Global_LupoDir & "\Apps\Extra", "Extra")
		_Apps_Find(-1, $Global_LupoDir & "\Apps\Games", "Games")
		_Apps_Find(-1, $Global_LupoDir & "\MyApps", "MyApps")
		$iChecking = 0
		If BinaryToString(InetRead($Global_Site & "downloads/ok.txt", 17)) = "YES" Then
			_Apps_Check($hClose, $hProgressBar, -2)
			$iNumberItems = _GUICtrlListView_GetItemCount($Global_ListView)
			For $K = 0 To $iNumberItems - 1
				If _GUICtrlListView_GetItemChecked($Global_ListView, $K) Then $iChecking = $iChecking + 1
			Next
			If $iChecking <> 0 Then
				If $iChecking = 1 Then
					$sString = "There is 1 update of Lupo PenSuite apps available." & @LF & "Do you want to update it now?"
				Else
					$sString = "There are " & $iChecking & " updates of Lupo PenSuite apps available." & @LF & "Do you want to update them now?"
				EndIf
				$iDecision = MsgBox(0x40004, "Check results", $sString & " (wait the ending message)")
				If $iDecision = 6 Then
					_Apps_Update($sLupoTempDir, 6, $hClose, $hProgressBar, -2)
					MsgBox(0x40000, "Update completed", $Global_SuiteName & " apps successfully updated.")
				EndIf
			EndIf
		EndIf
	EndIf

	GUIDelete($hGUI)
EndFunc   ;==>_Apps

Func _Welcome($hMainGUI)
	Local $hGUI, $hOK, $sState, $aCheckbox[3]

	$hGUI = GUICreate("Welcome to the Suite Manager!", 360, 160, -1, -1, -1, $WS_EX_TOOLWINDOW, $hMainGUI)
	GUICtrlCreateLabel('This software allow you to manage your Suite and all apps included in it. For a better experience you can select for which components do online check for updates:', 15, 10, 330, 46)
	GUICtrlSetFont(-1, 9, 360)

	$aCheckbox[0] = GUICtrlCreateCheckbox(" check for updates of this manager at its startup", 34, 62, 290, 20)
	$aCheckbox[1] = GUICtrlCreateCheckbox(" check for updates of the entire collection at Suite startup", 34, 62+20, 290, 20)
	$aCheckbox[2] = GUICtrlCreateCheckbox(" check for updates of single applications at Suite startup", 34, 62+40, 290, 20)

	$hOK = GUICtrlCreateButton("OK", 180-35, 127, 70, 24)

	GUISetState()
	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				IniWrite($Global_INI, "General", "AutoCheckMan", "OFF")
				ExitLoop

			Case $hOK
				$sState = "OFF"
				If GUICtrlRead($aCheckbox[0]) = 1 Then $sState = "ON"
				IniWrite($Global_INI, "General", "AutoCheckMan", $sState)

				$sState = "OFF"
				If GUICtrlRead($aCheckbox[1]) = 1 Then $sState = "ON"
				IniWrite($Global_INI, "General", "AutoCheck", $sState)

				$sState = "OFF"
				If GUICtrlRead($aCheckbox[2]) = 1 Then $sState = "ON"
				IniWrite($Global_INI, "General", "AutoCheckApps", $sState)
				ExitLoop

		EndSwitch
	WEnd

	GUIDelete($hGUI)
EndFunc   ;==>_Welcome

Func _Get_AppsDir($sAppType)
	Local $sAppsDir

	Switch $sAppType
		Case "Apps"
			$sAppsDir = $Global_LupoDir & "\Apps"
		Case "Extra"
			$sAppsDir = $Global_LupoDir & "\Apps\Extra"
		Case "Games"
			$sAppsDir = $Global_LupoDir & "\Apps\Games"
		Case "MyApps"
			$sAppsDir = $Global_LupoDir & "\MyApps"
		Case "Custom"
			$sAppsDir = $Global_CustomDir
	EndSwitch

	Return $sAppsDir
EndFunc   ;==>_Get_AppsDir

Func _Set_Proxy()
	Local $sProxyHost = IniRead($Global_INI, "Proxy", "ProxyHost", ""), $sProxyPort = IniRead($Global_INI, "Proxy", "ProxyPort", "")
	Local $sProxyUser = IniRead($Global_INI, "Proxy", "ProxyUsername", ""), $sProxyPassword = IniRead($Global_INI, "Proxy", "ProxyPassword", "")
	If StringLen($sProxyUser) > 0 Then
		HttpSetProxy(2, $sProxyHost & ":" & $sProxyPort, $sProxyUser, $sProxyPassword)
	ElseIf StringLen($sProxyHost) > 0 Then
		HttpSetProxy(2, $sProxyHost & ":" & $sProxyPort)
	Else
		HttpSetProxy(0)
	EndIf
EndFunc   ;==>_Set_Proxy

Func WM_NOTIFY($hWnd, $iMsg, $iwParam, $lParam)
	#forceref $hWnd, $iMsg, $iwParam
	Local $tNMITEMACTIVATE = DllStructCreate($tagNMITEMACTIVATE, $lParam)
	Local $hWndFrom = DllStructGetData($tNMITEMACTIVATE, 'hWndFrom')
	Local $Index = DllStructGetData($tNMITEMACTIVATE, 'Index')
	Local $Code = DllStructGetData($tNMITEMACTIVATE, 'Code')
	Switch $hWndFrom
		Case $Global_ListView
			Switch $Code
				Case $NM_RCLICK
					GUICtrlSendToDummy($Global_Dummy, $Index)
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_NOTIFY

Func ShowMenu($hWnd, $CtrlID, $nContextID)
	Local $arPos, $x, $y
	Local $hMenu = GUICtrlGetHandle($nContextID)
	$arPos = ControlGetPos($hWnd, "", $CtrlID)
	$x = $arPos[0]
	$y = $arPos[1] + $arPos[3]
	ClientToScreen($hWnd, $x, $y)
	DllCall("user32.dll", "int", "TrackPopupMenuEx", "hwnd", $hMenu, "int", 0, "int", $x, "int", $y, "hwnd", $hWnd, "ptr", 0)
EndFunc   ;==>ShowMenu

Func ClientToScreen($hWnd, ByRef $x, ByRef $y)
	Local $stPoint = DllStructCreate("int;int")
	DllStructSetData($stPoint, 1, $x)
	DllStructSetData($stPoint, 2, $y)
	DllCall("user32.dll", "int", "ClientToScreen", "hwnd", $hWnd, "ptr", DllStructGetPtr($stPoint))
	$x = DllStructGetData($stPoint, 1)
	$y = DllStructGetData($stPoint, 2)
	; release Struct not really needed as it is a local
	$stPoint = 0
EndFunc   ;==>ClientToScreen

Func __GUIImageList_AddIcon($hWnd, $sFile, $iIndex = 0, $fLarge = False)
	Local $tIcon, $iResult, $hIcon
	$tIcon = DllStructCreate("int Handle") 
	If $fLarge Then
		$iResult = _WinAPI_ExtractIconEx($sFile, $iIndex, DllStructGetPtr($tIcon), 0, 1)
	Else
		$iResult = _WinAPI_ExtractIconEx($sFile, $iIndex, 0, DllStructGetPtr($tIcon), 1)
	EndIf
	If $iResult <= 0 Then
		Return SetError(1, 0, -1)
	EndIf
	$hIcon = DllStructGetData($tIcon, "Handle")
	$iResult = _GUIImageList_ReplaceIcon($hWnd, -1, $hIcon)
	DllCall('user32.dll', 'int', 'DestroyIcon', 'ptr', $hIcon)
	If $iResult = -1 Then
		Return SetError(1, 0, -1)
	EndIf
	Return $iResult
EndFunc   ;==>__GUIImageList_AddIcon
