#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=lupo.ico
#AutoIt3Wrapper_outfile=Lupo_PenSuite.exe
#AutoIt3Wrapper_UseUpx=N
#AutoIt3Wrapper_Res_Description=Lupo PenSuite: The Collection of Portable Software for Everyone
#AutoIt3Wrapper_Res_Fileversion=2014.05.0.0
#AutoIt3Wrapper_Res_ProductVersion=2014.05.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Lupo PenSuite Team
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_Field=Website|http://www.lupopensuite.com
#AutoIt3Wrapper_Res_Field=E-Mail|comment at the website
#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6 -w 7
#AutoIt3Wrapper_Run_Obfuscator=Y
#Obfuscator_Parameters=/SF /SV /OM /CF=0 /CN=0 /CS=0 /CV=0
#AutoIt3Wrapper_res_requestedExecutionLevel=asInvoker
#AutoIt3Wrapper_Outfile_Type=exe
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Info: http://www.autoitscript.com/autoit3/scite/docs/AutoIt3Wrapper.htm
; Icons added to the resources can be used with TraySetIcon(@ScriptFullPath, -5) etc. and are stored with numbers -5, -6...

#include <File.au3>
#include <GUIConstantsEx.au3>

Global $Global_INI = @ScriptDir & "\Launcher\Manager\config.ini", $Global_ASuite = @ScriptDir & "\Launcher\ASuite.exe", $Global_Manager = @ScriptDir & "\Launcher\Manager\Manager.exe"
Global $Global_XML = @ScriptDir & "\Launcher\ASuite.xml", $Global_TempXML = @ScriptDir & "\Launcher\ASuiteTemp.xml", $Global_TempFile = @ScriptDir & "\Launcher\temp.txt"
Global $Global_LangPack = @ScriptDir & "\LangPack.exe", $Global_Browser = "..\..\Apps\Firefox Portable\FirefoxPortable.exe", $Global_Associator = "..\..\Apps\Extra\eXpresso\eXpresso.exe"

_Main()

Func _FixPath()
	Local $sLine, $sOldLine, $aArray, $sPath, $hInputOpen, $hOutputOpen

	$hInputOpen = FileOpen($Global_XML, 0)
	$hOutputOpen = FileOpen($Global_TempFile, 2)
	While 1
		$sLine = FileReadLine($hInputOpen)
		If @error = -1 Then ExitLoop
		If StringInStr($sLine, "$Drive") Then
			$sOldLine = $sLine
			$sLine = StringReplace($sLine, "$Drive", StringLeft(@ScriptDir, 2))
			If StringInStr($sLine, @ScriptDir) Then
				$aArray = StringRegExp($sLine, '<(.*?)>(.*?)</(.*?)>', 1)
				If IsArray($aArray) = 0 Or StringInStr($aArray[1], "\") = 0 Then
					$sLine = $sOldLine
				Else
					$sPath = StringReplace(StringTrimLeft(_PathGetRelative($Global_ASuite, $aArray[1]), 3), "\", "<xx>")
					$sLine = StringRegExpReplace($sLine, '<' & $aArray[0] & '>.*?</' & $aArray[2] & '>', '<' & $aArray[0] & '>' & $sPath & '</' & $aArray[2] & '>')
				EndIf
			Else
				$sLine = $sOldLine
			EndIf
			$sLine = StringReplace($sLine, "<xx>", "\")
		EndIf
		FileWriteLine($hOutputOpen, $sLine)
	WEnd
	FileClose($hInputOpen)
	FileClose($hOutputOpen)
	FileCopy($Global_TempFile, $Global_XML, 1)
	FileDelete($Global_TempFile)
EndFunc   ;==>_FixPath

Func _First()
	Local $hGUI, $hStart, $hManage, $iReturnValue

	$hGUI = GUICreate("Welcome", 370, 156)
	GUISetIcon("lupo.ico")
	GUISetBkColor(0x0A0A52)

	GUICtrlCreateLabel("Welcome to Lupo PenSuite!", 85, 10, 360, 16)
	GUICtrlSetColor(-1, 0xE5E5E5)
	GUICtrlSetFont(-1, 9, 600)

	GUICtrlCreateLabel("The Collection of Portable Software for Everyone", 55, 26, 360, 16)
	GUICtrlSetColor(-1, 0xE5E5E5)
	GUICtrlSetFont(-1, 9, 360)

	GUICtrlCreateLabel('If it is the first time you use this collection, click the "Start" button.', 18, 56, 340, 16)
	GUICtrlSetColor(-1, 0xE5E5E5)

	GUICtrlCreateLabel('If instead you want to configure your Suite before start it (eg. to set the auto-check for updates, to import old settings or to choose an Icon-Set), click the "Manage" button.', 18, 75, 340, 48)
	GUICtrlSetColor(-1, 0xE5E5E5)

	$hStart = GUICtrlCreateButton("Start", 185 - 40 - 68, 122, 68, 24)
	$hManage = GUICtrlCreateButton("Manage", 185 + 40, 122, 68, 24)
	GUICtrlSetState($hStart, $GUI_FOCUS)

	GUISetState()
	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				$iReturnValue = 0
				ExitLoop

			Case $hStart
				$iReturnValue = 1
				ExitLoop

			Case $hManage
				$iReturnValue = 2
				ExitLoop

		EndSwitch
	WEnd

	GUIDelete($hGUI)
	Return $iReturnValue
EndFunc   ;==>_First

Func _Main()
	Local $sData, $hProcessID, $hSubProcessID, $sAssociator, $fFixPath, $fAutoCheck, $fAutoCheckApps, $iDecision

	If FileExists($Global_LangPack) Then
		FileDelete($Global_LangPack)
	EndIf
	If FileExists($Global_TempXML) Then
		FileMove($Global_TempXML, $Global_XML, 1)
	EndIf

	If FileExists($Global_Manager) Then
		If FileExists($Global_INI) = 0 Then
			$sData = "Version=0" & @LF & "Edition=Full" & @LF & "Language=English" & @LF & "AutoCheck=OFF" & @LF & "AutoCheckApps=OFF" & @LF & "AutoCheckMan=" & @LF & "UpdateMode=Keep" & @LF & "Browser=" & $Global_Browser & @LF & "CustomFolder=None" & @LF & "UseCustomFolder=NO" & @LF & "BackupDir="
			IniWriteSection($Global_INI, "General", $sData)
			$sData = "ProxyHost=" & @LF & "ProxyPort=" & @LF & "ProxyUsername=" & @LF & "ProxyPassword="
			IniWriteSection($Global_INI, "Proxy", $sData)
			$sData = "IconSet=5"
			IniWriteSection($Global_INI, "Switcher", $sData)
			$sData = "FirstTime=YES" & @LF & "FixPath=YES" & @LF & "Associate=OFF" & @LF & "Associator=" & $Global_Associator
			IniWriteSection($Global_INI, "Starter", $sData)
		EndIf
		$fFixPath = IniRead($Global_INI, "Starter", "FixPath", "YES")
		Sleep(600)

		If IniRead($Global_INI, "Starter", "FirstTime", "YES") = "YES" Then
			If FileExists($Global_ASuite) Then
				$iDecision = _First()
				If $iDecision = 0 Then Exit
				IniWrite($Global_INI, "Starter", "FirstTime", "NO")
				If $iDecision = 2 Then RunWait($Global_Manager)
				If $fFixPath = "YES" Then _FixPath()
				Sleep(600)
				$hProcessID = Run($Global_ASuite)
			EndIf
		Else
			If FileExists($Global_ASuite) Then
				If $fFixPath = "YES" Then _FixPath()
				$hProcessID = Run($Global_ASuite)
			EndIf
			$fAutoCheck = IniRead($Global_INI, "General", "AutoCheck", "OFF")
			$fAutoCheckApps = IniRead($Global_INI, "General", "AutoCheckApps", "OFF")
			If $fAutoCheck = "ON" Or $fAutoCheckApps = "ON" Then
				Sleep(8000)
				Run($Global_Manager & " " & $fAutoCheck & " " & $fAutoCheckApps)
			EndIf
		EndIf
	Else
		If FileExists($Global_ASuite) Then
			If $fFixPath = "YES" Then _FixPath()
			$hProcessID = Run($Global_ASuite)
		EndIf
	EndIf

	$sAssociator = IniRead($Global_INI, "Starter", "Associator", "")
	If $sAssociator = "" Then $sAssociator = $Global_Associator
	If StringInStr($sAssociator, "..\") Then $sAssociator = @ScriptDir & "\Launcher\Manager\" & $sAssociator
	If IniRead($Global_INI, "Starter", "Associate", "OFF") = "ON" And FileExists($sAssociator) Then
		Sleep(1000)
		$hSubProcessID = Run($sAssociator)
		While 1
			Sleep(250)
			If ProcessExists($hProcessID) = 0 Then ExitLoop
		WEnd
		If $hSubProcessID <> 0 Then ProcessClose($hSubProcessID)
	EndIf
EndFunc   ;==>_Main
